/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");

var aTabTR = new Arbre('Compta/Etats/Tab_TR.tmpl', 'tabtr');


function init() {
  try {

		document.getElementById('date_bord').value = "AU "+ parent.document.getElementById('date_courante').value;

		var aGrille = new Arbre("Compta/GetRDF/balance_agee.tmpl", "grille");
		aGrille.initTree();

		aTabTR.initTree();

		var qGraph = new QueryHttp("Compta/Etats/Tresorerie.tmpl");
		var result = qGraph.execute();
		var contenu = result.responseXML.documentElement;
		document.getElementById('tresorerie').setAttribute("src", getDirGraph() + contenu.getAttribute('graph'));

		document.getElementById('JM30').value = contenu.getAttribute('JM30');
		document.getElementById('J').value = contenu.getAttribute('J');
		document.getElementById('JP15').value = contenu.getAttribute('JP15');
		document.getElementById('JP30').value = contenu.getAttribute('JP30');
		document.getElementById('AutresDettes').value = contenu.getAttribute('AutresDettes');
		document.getElementById('Fournisseurs30').value = contenu.getAttribute('Fournisseurs30');
		document.getElementById('Clients30').value = contenu.getAttribute('Clients30');

  } catch (e) {
    recup_erreur(e);
  }
}


function reloadTabTR(d) {
	try {

		aTabTR.setParam("Distance", d);
    aTabTR.initTree();

	} catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/compta/user/menu_exercice.xul";

  } catch (e) {
    recup_erreur(e);
  }
}


function balance(t) {
  try {

    window.location = "chrome://opensi/content/compta/user/edition/options_balanceagee.xul?"+ cookie() +"&Type="+ t.label;

  } catch (e) {
    recup_erreur(e);
  }
}
