/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

var oebl_aBon = new Arbre('Facturation/Affaires/list-ligneBonLivraison.tmpl', 'oebl-bonLivraison');
var oebl_aCom = new Arbre('Facturation/Affaires/liste-articlesALivrer.tmpl', 'oebl-commande');

var oebl_aPaysLiv = new Arbre("ComboListe/combo-pays.tmpl", "oebl-codePaysLiv");
var oebl_aModesExpedition = new Arbre("ComboListe/combo-modesExpedition.tmpl","oebl-modeExpedition");

var oebl_qGetBonLiv = new QueryHttp('Facturation/Affaires/loadBonLivraison.tmpl');
var oebl_qInfosFournisseur = new QueryHttp('Facturation/Affaires/getInfosFournisseur.tmpl');
var oebl_qAjouterToutBon = new QueryHttp('Facturation/Affaires/addAllBL.tmpl');
var oebl_qAjouterToutBonDispo = new QueryHttp('Facturation/Affaires/addAllDispoBL.tmpl');
var oebl_qEnleverToutBon = new QueryHttp('Facturation/Affaires/removeAllBL.tmpl');
var oebl_qEnleverArticles = new QueryHttp('Facturation/Affaires/removeLigneBL.tmpl');

var oebl_qSupBL = new QueryHttp("Facturation/Affaires/supprimerBL.tmpl");
var oebl_qAnnuler = new QueryHttp("Facturation/Affaires/cancelBonLivraison.tmpl");

var oebl_aLiensColis = new Arbre("Facturation/Affaires/list-colisBL.tmpl","oebl-liensColis");
var oebl_aVersion = new Arbre("Facturation/Affaires/list-versionBonLivraison.tmpl","oebl-listeVersion");
var oebl_aLangues = new Arbre("ComboListe/combo-langues.tmpl", "oebl-langueDefaut");
var oebl_aDepots = new Arbre('ComboListe/combo-depotsStock.tmpl', 'oebl-depot');


var oebl_bloquerBLSansStock;
var oebl_mode;
var oebl_etatBon;
var oebl_statutExpedition;
var oebl_currentCodePaysLiv;
var oebl_langueDefaut;
var oebl_bonChiffre;
var oebl_editBP;
var oebl_editLF;
var oebl_editCF;
var oebl_etapePrepaBL;
var oebl_etapePrepaOL;
var oebl_etapePrepaLF;
var oebl_defautEtapePrepaBL;
var oebl_defautEtapePrepaOL;
var oebl_clientId = "";
var oebl_fournisseurId = "";
var oebl_typeExpedition;
var oebl_curDepot;
var oebl_chargerModeExpedition;
var oebl_depotCommande;
var oebl_typeDepotCommande;
var oebl_tiersDepotCommande;
var oebl_actSuiviSerie;
var oebl_actSuiviLot;
var oebl_modified = false;
var oebl_envoiTrans;
var oebl_colisageAuto;
var oebl_nonPaye;
var oebl_specCMBL;
var oebl_specHMLBP;
var oebl_specHMBEP;
var oebl_listLigneId = "";


function oebl_init() {
	try {

		document.getElementById('oebl-rowFax').collapsed = !gShowFax;

		oebl_bonChiffre = gConfig.isBLChiffre();
		oebl_editBP = gConfig.isGACEditBP();
		oebl_editLF = gConfig.isGACEditLF();
		oebl_editCF = gConfig.isGACEditCF();
		oebl_envoiTrans = gConfig.isGACEnvoiTransFTP();

		oebl_actSuiviLot = gConfig.isActSuiviLot();
		var actNbPieces = gConfig.isActNbPieces();
		oebl_actSuiviSerie = gConfig.isActSuiviSerie();

		oebl_defautEtapePrepaBL = gConfig.isEtapePrepaBLCC();
		oebl_defautEtapePrepaOL = gConfig.isEtapePrepaOL();
		oebl_etapePrepaLF = gConfig.isEtapePrepaLF();

		oebl_bloquerBLSansStock = gConfig.isBloquerBLSansStock();
		oebl_colisageAuto = gConfig.isColisageAuto();
		document.getElementById('oebl-solder').collapsed = gConfig.isSoldeAutoCC();

		oebl_specCMBL = gConfig.isSpecCMBL();
		oebl_specHMLBP = gConfig.isSpecHMLBP();
		oebl_specHMBEP = gConfig.isSpecHMBEP();

		if (!isEmpty(gConfig.getUrlCTCControler())) {
			document.getElementById('oebl-colCTC').collapsed = false;
			document.getElementById('oebl-colCTC').setAttribute("ignoreincolumnpicker", false);
		}

		document.getElementById('oebl-bConsultSerieLigne').collapsed = !oebl_actSuiviSerie;
		document.getElementById('oebl-boxSaisieSerie').collapsed = !oebl_actSuiviSerie || gReadOnly;

		if (!oebl_actSuiviLot) {
			document.getElementById('oebl-colNumLotLiv').collapsed = true;
			document.getElementById('oebl-colNumLotLiv').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebl-colDatePeremptionLiv').collapsed = true;
			document.getElementById('oebl-colDatePeremptionLiv').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebl-rowNumLot').collapsed = true;
			document.getElementById('oebl-rowDLC').collapsed = true;
		}

		if (!actNbPieces) {
			document.getElementById('oebl-colNbPiecesDev').collapsed = true;
			document.getElementById('oebl-colNbPiecesDev').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebl-colNbPiecesLiv').collapsed = true;
			document.getElementById('oebl-colNbPiecesLiv').setAttribute('ignoreincolumnpicker', true);
			document.getElementById('oebl-rowNbPieces').collapsed = true;
		}

		oebl_aPaysLiv.initTree(oebl_initPaysLiv);

		if (gReadOnly) {
			document.getElementById('oebl-bGenerateBP').collapsed = true;
			document.getElementById('oebl-bGenerateBL').collapsed = true;
			document.getElementById('oebl-bEnregistrer').collapsed = true;
			document.getElementById('oebl-bAnnulerColis').collapsed = true;
			document.getElementById('oebl-tabBon').setAttribute('tooltiptext', "Lecture seule");
		}

		if (!gAccesCoutAchat) {
			document.getElementById('oebl-colPrixAchat').setAttribute("ignoreincolumnpicker", true);
			document.getElementById('oebl-colPrixAchatCFLiv').setAttribute("ignoreincolumnpicker", true);
		}

		document.getElementById("oebl-colVolumeColis").setAttribute("label", "Volume ("+ gConfig.getSymboleUniteVolume() +")");

  } catch (e) {
  	recup_erreur(e);
  }
}


function oebl_initPaysLiv() {
	try {

		document.getElementById('oebl-codePaysLiv').value = "FR";

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_initModeExpedition() {
	try {

		document.getElementById('oebl-modeExpedition').value = oebl_chargerModeExpedition;

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_chargerModesExpedition(selection) {
	try {
		oebl_chargerModeExpedition = selection;
		oebl_aModesExpedition.setParam("Selection", oebl_chargerModeExpedition);
		oebl_aModesExpedition.initTree(oebl_initModeExpedition);
	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_chargerDepot(selection) {
	try {

		oebl_curDepot = selection;
		oebl_initModePrepa();

		oebl_aDepots.clearParams();
		oebl_aDepots.setParam("Selection", selection);
		oebl_aDepots.setParam("Depot_Vente", false);
		oebl_aDepots.setParam("Depot_Quarantaine", false);
		if (oebl_typeExpedition!="L") {
			oebl_aDepots.setParam("Depot_Logistique", false);
		}
		else {
			oebl_aDepots.setParam("Depot_Expedition", false);
			oebl_aDepots.setParam("Logisticien", oebl_fournisseurId);
		}
		oebl_aDepots.initTree(oebl_initDepot);

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_initDepot() {
	try {

		document.getElementById('oebl-depot').value = oebl_curDepot;
		document.getElementById('oebl-rowDepot').collapsed = (oebl_typeExpedition=="F");

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_getDepotDefaut() {
	try {

		var depotId = "";
		if (oebl_typeExpedition=="B" && oebl_typeDepotCommande=="E") {
			depotId = oebl_depotCommande;
		}
		else if (oebl_typeExpedition=="L") {
			// Si le dpt de la commande a pour logisticien le fournisseur du BL, on le prend
			if (oebl_typeDepotCommande=="L" && oebl_fournisseurId==oebl_tiersDepotCommande) {
				depotId = oebl_depotCommande;
			}
			else {
				// Sinon si le fournisseur du BL est reli  un seul dpt, on prend ce dpt
				var qDepotLogisticien = new QueryHttp("Facturation/Affaires/getDepotLogisticien.tmpl");
				qDepotLogisticien.setParam("Fournisseur_Id", oebl_fournisseurId);
				var result = qDepotLogisticien.execute();
				var contenu = result.responseXML.documentElement;
				if (contenu.getAttribute("Nb_Depots")=="1") {
					depotId = contenu.getAttribute("Depot_Id");
				}
			}
		}
		return depotId;

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_loadDepotCommande() {
	try {
		// FONCTION APPELEE UNIQUEMENT LORS D'UN NOUVEAU BL
		// En effet, elle est inutile lorsque le BL est charg
		var qDepotExp = new QueryHttp("Facturation/Affaires/getDepotCommande.tmpl");
		qDepotExp.setParam("Commande_Id", commandeId);
		var result = qDepotExp.execute();
		var contenu = result.responseXML.documentElement;

		oebl_depotCommande = contenu.getAttribute("Depot_Id");
		oebl_typeDepotCommande = contenu.getAttribute("Type");
		if (oebl_typeDepotCommande=="L") {
			oebl_tiersDepotCommande = contenu.getAttribute("Logisticien");
		}
	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_reinitialiser() {
	try {

		oebl_mode = "C";
		oebl_etatBon = "N";
		oebl_clientId = "";
		oebl_curDepot = "";
		oebl_initModePrepa();
		oebl_chargerModeExpedition = "";
		oebl_depotCommande = "";
		oebl_typeDepotCommande = "";
		oebl_tiersDepotCommande = "";
		oebl_nonPaye = false;

		oebl_aCom.deleteTree();
		oebl_aBon.deleteTree();

		document.getElementById('oebl-deckBonLivraison').selectedIndex = 0;
		document.getElementById('oebl-tabBoxBon').selectedIndex = 0;
		document.getElementById('oebl-labelLogin').value = "";
		document.getElementById('oebl-rowLoginWeb').collapsed = true;
		document.getElementById('oebl-raisonSociale').value = "";
		document.getElementById('oebl-adresseFact').value = "";
		document.getElementById('oebl-adresse2Fact').value = "";
		document.getElementById('oebl-adresse3Fact').value = "";
		document.getElementById('oebl-codePostalFact').value = "";
		document.getElementById('oebl-villeFact').value = "";
		document.getElementById('oebl-affaire').value = "";
		document.getElementById('oebl-numClient').value = "";
		document.getElementById('oebl-denominationLiv').value = "";
		document.getElementById('oebl-adresse1Liv').value = "";
		document.getElementById('oebl-adresse2Liv').value = "";
		document.getElementById('oebl-adresse3Liv').value = "";
		document.getElementById('oebl-codePostalLiv').value = "";
		document.getElementById('oebl-villeLiv').value = "";
		document.getElementById('oebl-codePaysLiv').value = "FR";
		document.getElementById('oebl-civInterLiv').value = "0";
		document.getElementById('oebl-nomInterLiv').value = "";
		document.getElementById('oebl-prenomInterLiv').value = "";
		document.getElementById('oebl-telInter1Liv').value = "";
		document.getElementById('oebl-telInter2Liv').value = "";
		document.getElementById('oebl-faxInterLiv').value = "";
		document.getElementById('oebl-emailInterLiv').value = "";
		document.getElementById('oebl-tabBon').setAttribute('image', gReadOnly?'chrome://opensi/content/design/icones/readonly.png':null);
		document.getElementById('oebl-lblNumBL').value = "";
		document.getElementById('oebl-lblDateBL').value = "";
		document.getElementById('oebl-indications').value = "";
		document.getElementById('oebl-infoExpeLot').value = "";
		document.getElementById('oebl-infoPrepaExpe').value = "";
		document.getElementById('oebl-infoEnvoiTrans').value = "";
		document.getElementById('oebl-infoExpeLot').collapsed = true;
		document.getElementById('oebl-infoPrepaExpe').collapsed = true;
		document.getElementById('oebl-infoEnvoiTrans').collapsed = true;
		document.getElementById('oebl-dateConfirmation').value = "";
		document.getElementById('oebl-rowDateConfirmation').collapsed = true;

		document.getElementById('oebl-tabVersionDocument').collapsed=true;
		oebl_aVersion.deleteTree();

		document.getElementById('oebl-tabBoxAdresses').selectedIndex = 1;

		document.getElementById('oebl-numFournisseur').value = "";
		document.getElementById('oebl-denominationFournisseur').value = "";
		document.getElementById('oebl-adresse1Fournisseur').value = "";
		document.getElementById('oebl-adresse2Fournisseur').value = "";
		document.getElementById('oebl-adresse3Fournisseur').value = "";
		document.getElementById('oebl-cpFournisseur').value = "";
		document.getElementById('oebl-villeFournisseur').value = "";

		oebl_aLiensColis.deleteTree();
		oebl_aDepots.deleteTree();
		document.getElementById('oebl-depot').value = "";
		document.getElementById('oebl-numero').value = "";
		document.getElementById('oebl-numSerie').value = "";
		document.getElementById('oebl-dateBL').value = "";
		document.getElementById('oebl-numeroBP').value = "";
		document.getElementById('oebl-dateBP').value = "";
		document.getElementById('oebl-etat').value = "";
		document.getElementById('oebl-commentairesFin').value = "";
		document.getElementById('oebl-commentairesInt').value = "";
		document.getElementById('oebl-nbPalettes').value = "";
		document.getElementById('oebl-fraisSup').value = "0.00";
		document.getElementById('oebl-solder').checked = false;
		document.getElementById('oebl-envoiTrans').checked = false;
		document.getElementById('oebl-numLot').value = "";
		document.getElementById('oebl-datePeremption').value = "";
		document.getElementById('oebl-nbPieces').value = "";
		document.getElementById('oebl-quantite').value = "";
		document.getElementById('oebl-creation').value = "";
		document.getElementById('oebl-modification').value = "";
		document.getElementById('oebl-fiche').value = "";
		document.getElementById('oebl-modeExpedition').selectedIndex = 0;
		document.getElementById('oebl-consignesLiv').value = "";
		document.getElementById('oebl-pointRetrait').value = "";
		document.getElementById('oebl-dateExpedition').value = "";
		oebl_modified = false;

		document.getElementById('oebl-chercherAdrLiv').disabled = true;
		document.getElementById('oebl-chercherInterLiv').disabled = true;
		document.getElementById('oebl-chercherRelais').disabled = true;
		document.getElementById('oebl-bChoisirMentions').disabled = true;
		document.getElementById('oebl-bAjouter').disabled = true;
		document.getElementById('oebl-bToutAjouter').disabled = true;
		document.getElementById('oebl-bToutAjouterDispo').disabled = true;
		document.getElementById('oebl-bToutAjouterDispo').collapsed = true;
		document.getElementById('oebl-bEnlever').disabled = true;
		document.getElementById('oebl-bToutEnlever').disabled = true;
		document.getElementById('oebl-bEnregistrer').disabled = true;
		document.getElementById('oebl-bGenerateBP').disabled = true;
		document.getElementById('oebl-bGenerateBL').disabled = true;
		document.getElementById('oebl-bAnnuler').disabled = true;
		document.getElementById('oebl-bConfirmer').collapsed = true;
		document.getElementById('oebl-bSupprimer').disabled = true;
		document.getElementById('oebl-bEditionBL').disabled = true;
		document.getElementById('oebl-bColisage').disabled = true;
		document.getElementById('oebl-bEditionBP').disabled = true;
		document.getElementById('oebl-bAnnulerColis').disabled = true;
		document.getElementById('oebl-bCsvColisage').disabled = true;
		document.getElementById('oebl-bPdfColisage').disabled = true;

    document.getElementById('oebl-solder').disabled = true;
		document.getElementById('oebl-envoiTrans').disabled = true;

    document.getElementById('oebl-depot').disabled = true;
    document.getElementById('oebl-rowDepot').collapsed = true;
		document.getElementById('oebl-modeExpedition').disabled = true;
		document.getElementById('oebl-pointRetrait').disabled = true;
		document.getElementById('oebl-dateExpedition').disabled = true;
		document.getElementById('oebl-consignesLiv').disabled = true;

		document.getElementById('oebl-denominationLiv').setAttribute('readonly', true);
		document.getElementById('oebl-adresse1Liv').setAttribute('readonly', true);
		document.getElementById('oebl-adresse2Liv').setAttribute('readonly', true);
		document.getElementById('oebl-adresse3Liv').setAttribute('readonly', true);
		document.getElementById('oebl-codePostalLiv').setAttribute('readonly', true);
		document.getElementById('oebl-villeLiv').setAttribute('readonly', true);
		document.getElementById('oebl-codePaysLiv').disabled = true;
		document.getElementById('oebl-civInterLiv').disabled = true;
		document.getElementById('oebl-nomInterLiv').setAttribute('readonly', true);
		document.getElementById('oebl-prenomInterLiv').setAttribute('readonly', true);
		document.getElementById('oebl-telInter1Liv').setAttribute('readonly', true);
		document.getElementById('oebl-telInter2Liv').setAttribute('readonly', true);
		document.getElementById('oebl-faxInterLiv').setAttribute('readonly', true);
		document.getElementById('oebl-emailInterLiv').setAttribute('readonly', true);

		document.getElementById('oebl-commentairesFin').disabled = true;
		document.getElementById('oebl-commentairesInt').disabled = true;
		document.getElementById('oebl-nbColis').disabled = true;
		document.getElementById('oebl-nbPalettes').disabled = true;
		document.getElementById('oebl-fraisSup').disabled = true;
		document.getElementById('oebl-numLot').disabled = true;
		document.getElementById('oebl-datePeremption').disabled = true;
		document.getElementById('oebl-nbPieces').disabled = true;
		document.getElementById('oebl-quantite').disabled = true;
		document.getElementById('oebl-commande').disabled = true;
		document.getElementById('oebl-bConsultSerieLigne').disabled = true;

		document.getElementById('oebl-bOuvrirCommentairesCaches').disabled = true;

		document.getElementById('oebl-groupboxFournisseur').collapsed = true;
		document.getElementById('oebl-bEditionBL').collapsed = true;
		document.getElementById('oebl-bColisage').collapsed = true;
		document.getElementById('oebl-bEditionBP').collapsed = true;
		document.getElementById('oebl-envoiTrans').collapsed = true;

		document.getElementById('oebl-boxSaisieSerie').collapsed = (!oebl_actSuiviSerie || oebl_etatBon!="N" || gReadOnly);

		document.getElementById('oebl-barEdition').collapsed = true;
		document.getElementById('oebl-chkBonChiffre').collapsed = true;
		document.getElementById('oebl-chkCFChiffre').collapsed = true;
		document.getElementById('oebl-chkEditLF').collapsed = true;
		document.getElementById('oebl-chkEditCF').collapsed = true;
		document.getElementById('oebl-boxLangue').collapsed = true;
		document.getElementById('oebl-chkBonChiffre').checked = oebl_bonChiffre;
		document.getElementById('oebl-chkCFChiffre').checked = true;
		document.getElementById('oebl-chkEditBP').checked = oebl_typeExpedition=="B" && !oebl_etapePrepaBL && oebl_editBP;
		document.getElementById('oebl-chkEditCF').checked = oebl_typeExpedition=="F" && oebl_editCF;
		document.getElementById('oebl-chkEditLF').checked = oebl_typeExpedition=="F" && oebl_editLF;

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_changerDepot() {
	try {

		var depotId = document.getElementById('oebl-depot').value;
		document.getElementById('oebl-bToutAjouterDispo').disabled = isEmpty(depotId);
		oebl_disableAjouter(true,false);
		oebl_enregistrerBon(true);
		oebl_aCom.setParam("Depot_Id", depotId);
		oebl_aCom.initTree();

  } catch (e) {
    recup_erreur(e);
  }
}


function oebl_choisirFournisseur() {
	try {

		if (oebl_typeExpedition=="F") {
			var url = "chrome://opensi/content/facturation/user/affaires/popup-choixFournisseurLivDirecte.xul";
			window.openDialog(url,'','chrome,modal,centerscreen', oebl_retourChoisirFournisseur, commandeId);
		}
		else {
			var url = "chrome://opensi/content/facturation/user/affaires/popup-choixFournisseurLogisticien.xul";
			window.openDialog(url,'','chrome,modal,centerscreen', oebl_retourChoisirFournisseur);
		}

    if (isEmpty(oebl_fournisseurId)) {
      retourFicheAffaire();
		}

  } catch (e) {
    recup_erreur(e);
  }
}


function oebl_retourChoisirFournisseur(fournisseurId, listLigneId) {
	try {

		oebl_fournisseurId = fournisseurId;

		oebl_qInfosFournisseur.setParam("Fournisseur_Id", fournisseurId);
		var result = oebl_qInfosFournisseur.execute();
		var contenu = result.responseXML.documentElement;

		document.getElementById('oebl-numFournisseur').value = contenu.getAttribute('Num_Fournisseur');
		document.getElementById('oebl-denominationFournisseur').value = contenu.getAttribute('Denomination');
		document.getElementById('oebl-adresse1Fournisseur').value = contenu.getAttribute('Adresse_1');
		document.getElementById('oebl-adresse2Fournisseur').value = contenu.getAttribute('Adresse_2');
		document.getElementById('oebl-adresse3Fournisseur').value = contenu.getAttribute('Adresse_3');
		document.getElementById('oebl-cpFournisseur').value = contenu.getAttribute('Code_Postal');
		document.getElementById('oebl-villeFournisseur').value = contenu.getAttribute('Ville');

		oebl_afficherColonnesFourn();

		oebl_listLigneId = (listLigneId==null?"":listLigneId);

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_afficherColonnesFourn() {
	try {

		var afficher = (oebl_typeExpedition=="F");

		document.getElementById('oebl-colPrixAchat').collapsed = !afficher || !gAccesCoutAchat;
		document.getElementById('oebl-colFournPrincipal').collapsed = !afficher;
		document.getElementById('oebl-colStockFourn').collapsed = !afficher;
		document.getElementById('oebl-colQuantiteDispo').collapsed = afficher || !oma_calculStock;

		if (!afficher) {
			document.getElementById('oebl-colPrixAchat').setAttribute("ignoreincolumnpicker", true);
			document.getElementById('oebl-colFournPrincipal').setAttribute("ignoreincolumnpicker", true);
			document.getElementById('oebl-colStockFourn').setAttribute("ignoreincolumnpicker", true);
		}
		else {
			if (gAccesCoutAchat) {
				document.getElementById('oebl-colPrixAchat').removeAttribute("ignoreincolumnpicker");
			}
			document.getElementById('oebl-colFournPrincipal').removeAttribute("ignoreincolumnpicker");
			document.getElementById('oebl-colStockFourn').removeAttribute("ignoreincolumnpicker");
		}

		if (afficher || !oma_calculStock) {
			document.getElementById('oebl-colQuantiteDispo').setAttribute("ignoreincolumnpicker", true);
		}
		else {
			document.getElementById('oebl-colQuantiteDispo').removeAttribute("ignoreincolumnpicker");
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_debloquerChamps() {
	try {

		document.getElementById('oebl-chercherAdrLiv').disabled = false;
		document.getElementById('oebl-chercherRelais').disabled = false;
		document.getElementById('oebl-chercherInterLiv').disabled = false;
		document.getElementById('oebl-bChoisirMentions').disabled = false;
		document.getElementById('oebl-bAjouter').disabled = false;
		document.getElementById('oebl-bToutAjouter').disabled = oebl_bloquerBLSansStock && oebl_typeExpedition!="F";
		document.getElementById('oebl-bToutAjouterDispo').disabled = false;
		document.getElementById('oebl-bEnlever').disabled = false;
    document.getElementById('oebl-solder').disabled = false;
    document.getElementById('oebl-depot').disabled = false;
		document.getElementById('oebl-modeExpedition').disabled = false;
		document.getElementById('oebl-pointRetrait').disabled = false;
		document.getElementById('oebl-dateExpedition').disabled = false;
		document.getElementById('oebl-consignesLiv').disabled = false;

		document.getElementById('oebl-denominationLiv').removeAttribute('readonly');
		document.getElementById('oebl-adresse1Liv').removeAttribute('readonly');
		document.getElementById('oebl-adresse2Liv').removeAttribute('readonly');
		document.getElementById('oebl-adresse3Liv').removeAttribute('readonly');
		document.getElementById('oebl-codePostalLiv').removeAttribute('readonly');
		document.getElementById('oebl-villeLiv').removeAttribute('readonly');
		document.getElementById('oebl-codePaysLiv').disabled = false;
		document.getElementById('oebl-civInterLiv').disabled = false;
		document.getElementById('oebl-nomInterLiv').removeAttribute('readonly');
		document.getElementById('oebl-prenomInterLiv').removeAttribute('readonly');
		document.getElementById('oebl-telInter1Liv').removeAttribute('readonly');
		document.getElementById('oebl-telInter2Liv').removeAttribute('readonly');
		document.getElementById('oebl-faxInterLiv').removeAttribute('readonly');
		document.getElementById('oebl-emailInterLiv').removeAttribute('readonly');

		document.getElementById('oebl-commentairesFin').disabled = false;
		document.getElementById('oebl-commentairesInt').disabled = false;
		document.getElementById('oebl-nbColis').disabled = oebl_typeExpedition!="B" || oebl_colisageAuto;
		document.getElementById('oebl-nbPalettes').disabled = false;
		document.getElementById('oebl-fraisSup').disabled = false;
		document.getElementById('oebl-numLot').disabled = false;
		document.getElementById('oebl-datePeremption').disabled = false;
		document.getElementById('oebl-nbPieces').disabled = false;
		document.getElementById('oebl-quantite').disabled = false;
		document.getElementById('oebl-commande').disabled = false;
		document.getElementById('oebl-bEnregistrer').disabled = false;
		document.getElementById('oebl-bSupprimer').disabled = false;

		oebl_disableAjouter(true,false);
		oebl_disableEnlever(true,false);

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_reporterQteEntree() {
	try {

		if (oebl_aCom.isSelected()) {
			document.getElementById('oebl-nbPieces').value = oebl_aCom.getSelectedCellText('oebl-colNbPiecesDev');
			document.getElementById('oebl-quantite').value = oebl_aCom.getSelectedCellText('oebl-colQuantiteDev');
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_reporterQteSortie() {
	try {

		if (oebl_aBon.isSelected()) {
			document.getElementById('oebl-nbPieces').value = oebl_aBon.getSelectedCellText('oebl-colNbPiecesLiv');
			document.getElementById('oebl-quantite').value = oebl_aBon.getSelectedCellText('oebl-colQuantiteLiv');
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_disableAjouter(oebl_b,oebl_arbre) {
	try {

		if (!oebl_arbre || (oebl_aCom.isSelected() && oebl_mode!="V")) {
			var articleId = oebl_aCom.getSelectedCellText('oebl-colArticleIdDev');
			document.getElementById('oebl-bAjouter').disabled = oebl_b;
			document.getElementById('oebl-numLot').disabled = isEmpty(articleId);
			document.getElementById('oebl-datePeremption').disabled = isEmpty(articleId);
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_disableEnlever(oebl_b,oebl_arbre) {
	try {

		if (!oebl_arbre || (oebl_aBon.isSelected() && oebl_mode!="V")) {
			document.getElementById('oebl-bEnlever').disabled = oebl_b;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_nouveauBon() {
  try {

		oebl_aCom.clearParams();
		oebl_reinitialiser();
		document.getElementById('oebl-nbColis').value = "";
		oebl_aCom.setParam('Fournisseur_Id', "");

		if (oebl_typeExpedition=="B") {
			document.getElementById('oebl-bEditionBL').collapsed = false;
			document.getElementById('oebl-bColisage').collapsed = !oebl_specCMBL;
			document.getElementById('oebl-bEditionBP').collapsed = false;
			document.getElementById("oebl-gNbPalettes").collapsed = false;
			document.getElementById('oebl-lblNumBL').value = "N\u00B0 Bon de livraison :";
			document.getElementById('oebl-lblDateBL').value = "Date BL :";
			document.getElementById('oebl-bEditionBL').setAttribute('label', "Bon de livraison");
			document.getElementById('oebl-bEditionBL').setAttribute('tooltiptext', "visualiser le bon de livraison");
			document.getElementById('oebl-bGenerateBP').setAttribute('label', "G\u00E9n\u00E9rer le bon de pr\u00E9paration");
			document.getElementById('oebl-bGenerateBL').setAttribute('label', "G\u00E9n\u00E9rer le bon de livraison");
			document.getElementById('oebl-bGenerateBP').setAttribute('tooltiptext', "g\u00E9n\u00E9rer le bon de pr\u00E9paration");
			document.getElementById('oebl-bGenerateBL').setAttribute('tooltiptext', "g\u00E9n\u00E9rer le bon de livraison");
			document.getElementById('oebl-colPrixAchatCFLiv').collapsed = true;
			document.getElementById('oebl-colPrixAchatCFLiv').setAttribute("ignoreincolumnpicker", true);
			document.getElementById('oebl-rowNumeroBP').collapsed = false;
			document.getElementById('oebl-rowDateBP').collapsed = false;
		}
		else {
			document.getElementById('oebl-groupboxFournisseur').collapsed = false;
			document.getElementById("oebl-gNbPalettes").collapsed = true;
			document.getElementById('oebl-rowNumeroBP').collapsed = true;
			document.getElementById('oebl-rowDateBP').collapsed = true;

			oebl_choisirFournisseur();

			if (oebl_typeExpedition=="L") {
				document.getElementById('oebl-capFournisseur').setAttribute("label", "Logisticien");
				document.getElementById('oebl-lblNumBL').value = "N\u00B0 Ordre de livraison :";
				document.getElementById('oebl-lblDateBL').value = "Date OL :";
				document.getElementById('oebl-bEditionBL').setAttribute('label', "Ordre de livraison");
				document.getElementById('oebl-bEditionBL').setAttribute('tooltiptext', "visualiser l'ordre de livraison");
				document.getElementById('oebl-bGenerateBP').setAttribute('label', "G\u00E9n\u00E9rer l'ordre de livraison");
				document.getElementById('oebl-bGenerateBL').setAttribute('label', "G\u00E9n\u00E9rer l'ordre de livraison");
				document.getElementById('oebl-bGenerateBP').setAttribute('tooltiptext', "g\u00E9n\u00E9rer l'ordre de livraison");
				document.getElementById('oebl-bGenerateBL').setAttribute('tooltiptext', "g\u00E9n\u00E9rer l'ordre de livraison");
				document.getElementById('oebl-colPrixAchatCFLiv').collapsed = true;
				document.getElementById('oebl-colPrixAchatCFLiv').setAttribute("ignoreincolumnpicker", true);
			}
			else {
				oebl_aCom.setParam('Fournisseur_Id', oebl_fournisseurId);
				document.getElementById('oebl-capFournisseur').setAttribute("label", "Fournisseur");
				document.getElementById('oebl-lblNumBL').value = "N\u00B0 Livraison directe :";
				document.getElementById('oebl-lblDateBL').value = "Date LF :";
				document.getElementById('oebl-bEditionBL').setAttribute('label', "Commande fournisseur / BL");
				document.getElementById('oebl-bEditionBL').setAttribute('tooltiptext', "visualiser la commande fournisseur / BL");
				document.getElementById('oebl-bGenerateBP').setAttribute('label', "G\u00E9n\u00E9rer la commande");
				document.getElementById('oebl-bGenerateBL').setAttribute('label', "G\u00E9n\u00E9rer la commande");
				document.getElementById('oebl-bGenerateBP').setAttribute('tooltiptext', "g\u00E9n\u00E9rer la commande");
				document.getElementById('oebl-bGenerateBL').setAttribute('tooltiptext', "g\u00E9n\u00E9rer la commande");
				document.getElementById('oebl-colPrixAchatCFLiv').collapsed = !gAccesCoutAchat;
				if (gAccesCoutAchat) {
					document.getElementById('oebl-colPrixAchatCFLiv').removeAttribute("ignoreincolumnpicker");
				}
			}
		}

		document.getElementById('oebl-bToutAjouterDispo').collapsed = (!oma_calculStock || oebl_typeExpedition=="F");

		if (oebl_typeExpedition=="B" || !isEmpty(oebl_fournisseurId)) {
			oebl_mode = "C";
			oebl_aCom.setParam('Commande_Id', commandeId);

			var qLoad = new QueryHttp('Facturation/Affaires/getCommande.tmpl');
			qLoad.setParam("Commande_Id", commandeId);
			var result = qLoad.execute();

			var contenu = result.responseXML.documentElement;

			oebl_chargerModesExpedition(contenu.getAttribute('Mode_Expedition'));

			document.getElementById('oebl-consignesLiv').value = contenu.getAttribute('Consignes_Liv');
			document.getElementById('oebl-pointRetrait').value = contenu.getAttribute('Point_Retrait');
			document.getElementById('oebl-dateExpedition').value = contenu.getAttribute('Date_Expedition');

			oebl_clientId = contenu.getAttribute("Client_Id");
			document.getElementById('oebl-numClient').value = contenu.getAttribute("Num_Client");

			document.getElementById('oebl-denominationLiv').value = contenu.getAttribute('Denomination_Liv');
			document.getElementById('oebl-adresse1Liv').value = contenu.getAttribute('Adresse_1_Liv');
			document.getElementById('oebl-adresse2Liv').value = contenu.getAttribute('Adresse_2_Liv');
			document.getElementById('oebl-adresse3Liv').value = contenu.getAttribute('Adresse_3_Liv');
			document.getElementById('oebl-codePostalLiv').value = contenu.getAttribute('Code_Postal_Liv');
			document.getElementById('oebl-villeLiv').value = contenu.getAttribute('Ville_Liv');
			document.getElementById('oebl-codePaysLiv').value = contenu.getAttribute('Code_Pays_Liv');

			document.getElementById('oebl-civInterLiv').value = contenu.getAttribute("Civ_Inter_Liv");
			document.getElementById('oebl-nomInterLiv').value = contenu.getAttribute("Nom_Inter_Liv");
			document.getElementById('oebl-prenomInterLiv').value = contenu.getAttribute("Prenom_Inter_Liv");
			document.getElementById('oebl-telInter1Liv').value = contenu.getAttribute("Tel_Inter_1_Liv");
			document.getElementById('oebl-telInter2Liv').value = contenu.getAttribute("Tel_Inter_2_Liv");
			document.getElementById('oebl-faxInterLiv').value = contenu.getAttribute("Fax_Inter_Liv");
			document.getElementById('oebl-emailInterLiv').value = contenu.getAttribute("Email_Inter_Liv");

			document.getElementById('oebl-commentairesInt').value = contenu.getAttribute("Commentaires_Int");
			document.getElementById('oebl-commentairesFin').value = contenu.getAttribute("Commentaires_Fin");

			document.getElementById('oebl-indications').value = contenu.getAttribute("Indications");

			oebl_nonPaye = contenu.getAttribute("Statut_Paiement")!="T";

			oebl_aBon.deleteTree();

			if (oebl_typeExpedition!="F") {
				oebl_loadDepotCommande();
				var depotDefaut = oebl_getDepotDefaut();
				oebl_chargerDepot(depotDefaut);
				oebl_aCom.setParam("Depot_Id", depotDefaut);
			}
			oebl_aCom.initTree(oebl_debloquerChamps);

			oebl_setModified(false);
			document.getElementById('oebl-bSupprimer').collapsed = true;
			document.getElementById('oebl-bAnnuler').collapsed = true;
			document.getElementById('oebl-bConfirmer').collapsed = true;

			document.getElementById('oebl-bGenerateBP').disabled = true;
			document.getElementById('oebl-bGenerateBL').disabled = true;
			document.getElementById('oebl-bEditionBL').disabled = true;
			document.getElementById('oebl-bColisage').disabled = true;
			document.getElementById('oebl-bEditionBP').disabled = true;
			document.getElementById('oebl-corpsCommande').collapsed = false;
			document.getElementById('oebl-boxActions').collapsed = gReadOnly;

			oebl_afficherColonnesFourn();
			document.getElementById('oebl-affaire').value = ofa_numAffaire;
		}

		if (oebl_typeExpedition=="F" && !isEmpty(oebl_listLigneId)) {
			document.getElementById('oebl-modeExpedition').value = oebl_chargerModeExpedition;	// correction bug redmine 13496 - zen 9994 - Mode d'expdition remis  aucun si slection de lignes
			oebl_ajouterSelection(oebl_listLigneId);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_chargerBon(noRefreshArbres) {
  try {

		var refreshArbres = (noRefreshArbres!=true);

		oebl_reinitialiser();
		oebl_aBon.setParam('Fournisseur_Id', "");
		oebl_aBon.setParam('Bon_Id', bonId);
		oebl_aCom.setParam('Fournisseur_Id', "");
		oebl_aCom.setParam('Bon_Id', bonId);

		if (oebl_typeExpedition=="B") {
			document.getElementById('oebl-bEditionBL').collapsed = false;
			document.getElementById('oebl-bColisage').collapsed = !oebl_specCMBL;
			document.getElementById('oebl-bEditionBP').collapsed = false;
			document.getElementById('oebl-rowNumeroBP').collapsed = false;
			document.getElementById('oebl-rowDateBP').collapsed = false;
		}
		else {
			oebl_qInfosFournisseur.setParam("Fournisseur_Id", oebl_fournisseurId);
			var result = oebl_qInfosFournisseur.execute();

			var contenu = result.responseXML.documentElement;

			document.getElementById('oebl-numFournisseur').value = contenu.getAttribute('Num_Fournisseur');
			document.getElementById('oebl-denominationFournisseur').value = contenu.getAttribute('Denomination');
			document.getElementById('oebl-adresse1Fournisseur').value = contenu.getAttribute('Adresse_1');
			document.getElementById('oebl-adresse2Fournisseur').value = contenu.getAttribute('Adresse_2');
			document.getElementById('oebl-adresse3Fournisseur').value = contenu.getAttribute('Adresse_3');
			document.getElementById('oebl-cpFournisseur').value = contenu.getAttribute('Code_Postal');
			document.getElementById('oebl-villeFournisseur').value = contenu.getAttribute('Ville');
			document.getElementById('oebl-chkCFChiffre').checked = (contenu.getAttribute("CF_Chiffre")=="1");

			document.getElementById('oebl-groupboxFournisseur').collapsed = false;
			document.getElementById('oebl-rowNumeroBP').collapsed = true;
			document.getElementById('oebl-rowDateBP').collapsed = true;
		}

		oebl_mode = "M";
		oebl_qGetBonLiv.setParam("Bon_Id", bonId);
		var result = oebl_qGetBonLiv.execute();
		var contenu = result.responseXML.documentElement;
		var lblFiche = "";

		oebl_statutExpedition = contenu.getAttribute("Statut_Expedition");

		oebl_typeExpedition = contenu.getAttribute('Type_Liv');
		switch (oebl_typeExpedition) {
			case "B":
				document.getElementById('oebl-lblNumBL').value = "N\u00B0 Bon de livraison :";
				document.getElementById('oebl-lblDateBL').value = "Date BL :";
				document.getElementById('oebl-bEditionBL').setAttribute('label', "Bon de livraison");
				document.getElementById('oebl-bEditionBL').setAttribute('tooltiptext', "visualiser le bon de livraison");
				document.getElementById('oebl-bGenerateBP').setAttribute('label', "G\u00E9n\u00E9rer le bon de pr\u00E9paration");
				document.getElementById('oebl-bGenerateBL').setAttribute('label', "G\u00E9n\u00E9rer le bon de livraison");
				document.getElementById('oebl-bGenerateBP').setAttribute('tooltiptext', "g\u00E9n\u00E9rer le bon de pr\u00E9paration");
				document.getElementById('oebl-bGenerateBL').setAttribute('tooltiptext', "g\u00E9n\u00E9rer le bon de livraison");
				lblFiche = "Bon de livraison";
				document.getElementById('oebl-colPrixAchatCFLiv').collapsed = true;
				document.getElementById('oebl-colPrixAchatCFLiv').setAttribute("ignoreincolumnpicker", true);
			break;
			case "L":
				document.getElementById('oebl-capFournisseur').setAttribute("label", "Logisticien");
				document.getElementById('oebl-lblNumBL').value = "N\u00B0 Ordre de livraison :";
				document.getElementById('oebl-lblDateBL').value = "Date OL :";
				document.getElementById('oebl-bEditionBL').setAttribute('label', "Ordre de livraison");
				document.getElementById('oebl-bEditionBL').setAttribute('tooltiptext', "visualiser l'ordre de livraison");
				document.getElementById('oebl-bGenerateBP').setAttribute('label', "G\u00E9n\u00E9rer l'ordre de livraison");
				document.getElementById('oebl-bGenerateBL').setAttribute('label', (oebl_statutExpedition!="P"?"G\u00E9n\u00E9rer l'ordre de livraison":"Confirmer la pr\u00E9paration"));
				document.getElementById('oebl-bGenerateBP').setAttribute('tooltiptext', "g\u00E9n\u00E9rer l'ordre de livraison");
				document.getElementById('oebl-bGenerateBL').setAttribute('tooltiptext', (oebl_statutExpedition!="P"?"g\u00E9n\u00E9rer l'ordre de livraison":"confirmer la pr\u00E9paration de l'ordre de livraison"));
				lblFiche = "Ordre de livraison";
				document.getElementById('oebl-colPrixAchatCFLiv').collapsed = true;
				document.getElementById('oebl-colPrixAchatCFLiv').setAttribute("ignoreincolumnpicker", true);
			break;
			case "F":
				oebl_aCom.setParam('Fournisseur_Id', oebl_fournisseurId);
				document.getElementById('oebl-capFournisseur').setAttribute("label", "Fournisseur");
				document.getElementById('oebl-lblNumBL').value = "N\u00B0 Livraison directe :";
				document.getElementById('oebl-lblDateBL').value = "Date LF :";
				document.getElementById('oebl-bEditionBL').setAttribute('label', "Commande fournisseur / BL");
				document.getElementById('oebl-bEditionBL').setAttribute('tooltiptext', "visualiser la commande fournisseur / BL");
				document.getElementById('oebl-bGenerateBP').setAttribute('label', "G\u00E9n\u00E9rer la commande");
				document.getElementById('oebl-bGenerateBL').setAttribute('label', (oebl_statutExpedition!="P"?"G\u00E9n\u00E9rer la commande":"Confirmer la pr\u00E9paration"));
				document.getElementById('oebl-bGenerateBP').setAttribute('tooltiptext', "g\u00E9n\u00E9rer la commande");
				document.getElementById('oebl-bGenerateBL').setAttribute('tooltiptext', (oebl_statutExpedition!="P"?"g\u00E9n\u00E9rer la commande":"confirmer la pr\u00E9paration de la commande"));
				lblFiche = "Livraison directe";
				document.getElementById('oebl-colPrixAchatCFLiv').collapsed = !gAccesCoutAchat;
				if (gAccesCoutAchat) {
					document.getElementById('oebl-colPrixAchatCFLiv').removeAttribute("ignoreincolumnpicker");
				}
			break;
		}

		document.getElementById('oebl-bToutAjouterDispo').collapsed = (!oma_calculStock || oebl_typeExpedition=="F");

		oebl_etatBon = contenu.getAttribute("Etat");
		commandeId = contenu.getAttribute("Commande_Id");
		oebl_nonPaye = contenu.getAttribute("Non_Paye")=="true";

		oebl_chargerModesExpedition(contenu.getAttribute('Mode_Expedition'));
		oebl_chargerDepot(contenu.getAttribute("Depot_Id"));
		var etatCommande = contenu.getAttribute("Etat_Commande");
		document.getElementById('oebl-bConfirmer').collapsed = true;

		if (oebl_etatBon=="V") {
			switch (oebl_statutExpedition) {
				case "P":
					document.getElementById('oebl-etat').value = "A pr\u00E9parer";
					document.getElementById('oebl-bGenerateBL').collapsed = (gReadOnly && !gProfil.isValidationBL());
					document.getElementById('oebl-envoiTrans').collapsed = !(oebl_typeExpedition=="B" && oebl_envoiTrans);
					document.getElementById('oebl-envoiTrans').checked = (oebl_typeExpedition=="B" && oebl_envoiTrans);
					document.getElementById('oebl-envoiTrans').disabled = false;
				break;
				case "E":
					document.getElementById('oebl-etat').value = "Exp\u00E9di\u00E9";
				break;
				case "C":
					document.getElementById('oebl-etat').value = "Pr\u00EAt \u00E0 exp\u00E9dier";
					document.getElementById('oebl-bConfirmer').collapsed = gReadOnly;
				break;
			}

			document.getElementById('oebl-bSupprimer').collapsed = true;
			document.getElementById('oebl-bAnnuler').collapsed = (ofa_etatAffaire=="C" || etatCommande=="C" || (gReadOnly && ((oebl_statutExpedition=="P" && !gProfil.isAnnulationBP()) || (oebl_statutExpedition!="P" && !gProfil.isAnnulationBL()))));
			document.getElementById('oebl-corpsCommande').collapsed = true;
			document.getElementById('oebl-boxActions').collapsed = true;
			document.getElementById('oebl-bAnnuler').disabled = (ofa_etatAffaire=="C" || etatCommande=="C");
		}
		else if (oebl_etatBon=="A") {
			document.getElementById('oebl-etat').value = "Annul\u00E9";
			document.getElementById('oebl-bSupprimer').collapsed = true;
			document.getElementById('oebl-bAnnuler').collapsed = true;
			document.getElementById('oebl-corpsCommande').collapsed = true;
			document.getElementById('oebl-boxActions').collapsed = true;
		}
		else {
			document.getElementById('oebl-etat').value = "Non valid\u00E9";
			document.getElementById('oebl-bAnnuler').collapsed = true;
			document.getElementById('oebl-bSupprimer').collapsed = gReadOnly;
			document.getElementById('oebl-corpsCommande').collapsed = false;
			document.getElementById('oebl-boxActions').collapsed = gReadOnly;
			document.getElementById('oebl-envoiTrans').collapsed = !(oebl_typeExpedition=="B" && oebl_envoiTrans && !oebl_etapePrepaBL);
			document.getElementById('oebl-envoiTrans').checked = (oebl_typeExpedition=="B" && oebl_envoiTrans && !oebl_etapePrepaBL);
			document.getElementById('oebl-envoiTrans').disabled = oebl_etapePrepaBL;
		}

		if (oebl_etatBon!="N") {
			document.getElementById('oebl-bCsvColisage').disabled = false;
			document.getElementById('oebl-bPdfColisage').disabled = false;
			document.getElementById('oebl-tabVersionDocument').collapsed=false;
			oebl_initVersion();
			if (!isEmpty(contenu.getAttribute("Date_Expe_Lot"))) {
				document.getElementById('oebl-infoExpeLot').value = "Exp\u00E9dition en lot n\u00B0 "+ contenu.getAttribute("Num_Expedition") +" r\u00E9alis\u00E9e le "+ contenu.getAttribute("Date_Expe_Lot");
				document.getElementById('oebl-infoExpeLot').collapsed = false;
			}
			if (!isEmpty(contenu.getAttribute("Date_Prepa_Expe"))) {
				document.getElementById('oebl-infoPrepaExpe').value = "Pr\u00E9paration d'exp\u00E9dition valid\u00E9e le "+ contenu.getAttribute("Date_Prepa_Expe");
				document.getElementById('oebl-infoPrepaExpe').collapsed = false;
			}
			if (!isEmpty(contenu.getAttribute("Date_Confirmation"))) {
				document.getElementById('oebl-dateConfirmation').value = contenu.getAttribute("Date_Confirmation");
				document.getElementById('oebl-rowDateConfirmation').collapsed = false;
			}
			if (contenu.getAttribute("Envoi_Trans")=="true") {
				document.getElementById('oebl-infoEnvoiTrans').value = "Export transporteur effectu\u00E9";
				document.getElementById('oebl-infoEnvoiTrans').collapsed = false;
			}
		}
		document.getElementById('oebl-boxSaisieSerie').collapsed = (!oebl_actSuiviSerie || oebl_etatBon!="N" || gReadOnly);
		document.getElementById('oebl-consignesLiv').value = contenu.getAttribute('Consignes_Liv');
		document.getElementById('oebl-pointRetrait').value = contenu.getAttribute('Point_Retrait');
		document.getElementById('oebl-dateExpedition').value = contenu.getAttribute('Date_Expedition');
		document.getElementById('oebl-raisonSociale').value = contenu.getAttribute("Denomination");
		document.getElementById('oebl-adresseFact').value = contenu.getAttribute("Adresse_1");
		document.getElementById('oebl-adresse2Fact').value = contenu.getAttribute("Adresse_2");
		document.getElementById('oebl-adresse3Fact').value = contenu.getAttribute("Adresse_3");
		document.getElementById('oebl-codePostalFact').value = contenu.getAttribute("Code_Postal");
		document.getElementById('oebl-villeFact').value = contenu.getAttribute("Ville");
		oebl_clientId = contenu.getAttribute("Client_Id");
		document.getElementById('oebl-numClient').value = contenu.getAttribute("Num_Client");
		document.getElementById('oebl-labelLogin').value = contenu.getAttribute("Login_Web");
		document.getElementById('oebl-rowLoginWeb').collapsed = (contenu.getAttribute("Web")=="false");
		document.getElementById('oebl-affaire').value = contenu.getAttribute("Num_Affaire");

		document.getElementById('oebl-dateBL').value = contenu.getAttribute("Date_BL");
		document.getElementById('oebl-denominationLiv').value = contenu.getAttribute("Denomination_Liv");
		document.getElementById('oebl-adresse1Liv').value = contenu.getAttribute("Adresse_1_Liv");
		document.getElementById('oebl-adresse2Liv').value = contenu.getAttribute("Adresse_2_Liv");
		document.getElementById('oebl-adresse3Liv').value = contenu.getAttribute("Adresse_3_Liv");
		document.getElementById('oebl-codePostalLiv').value = contenu.getAttribute("Code_Postal_Liv");
		document.getElementById('oebl-villeLiv').value = contenu.getAttribute("Ville_Liv");
		document.getElementById('oebl-codePaysLiv').value = contenu.getAttribute("Code_Pays_Liv");
		document.getElementById('oebl-commentairesFin').value = contenu.getAttribute("Commentaires_Fin");
		document.getElementById('oebl-commentairesInt').value = contenu.getAttribute("Commentaires_Int");
		document.getElementById('oebl-numero').value = contenu.getAttribute("Numero_BL");
		if (oebl_etatBon!="N") {
			document.getElementById('oebl-nbColis').value = contenu.getAttribute("Nb_Colis");
		}
		document.getElementById('oebl-nbPalettes').value = contenu.getAttribute("Nb_Palettes");
		document.getElementById('oebl-fraisSup').value = contenu.getAttribute("Frais_Sup");
		document.getElementById('oebl-numeroBP').value = contenu.getAttribute("Numero_BP");
		document.getElementById('oebl-dateBP').value = contenu.getAttribute("Date_BP");

		document.getElementById('oebl-civInterLiv').value = contenu.getAttribute("Civ_Inter_Liv");
		document.getElementById('oebl-nomInterLiv').value = contenu.getAttribute("Nom_Inter_Liv");
		document.getElementById('oebl-prenomInterLiv').value = contenu.getAttribute("Prenom_Inter_Liv");
		document.getElementById('oebl-telInter1Liv').value = contenu.getAttribute("Tel_Inter_1_Liv");
		document.getElementById('oebl-telInter2Liv').value = contenu.getAttribute("Tel_Inter_2_Liv");
		document.getElementById('oebl-faxInterLiv').value = contenu.getAttribute("Fax_Inter_Liv");
		document.getElementById('oebl-emailInterLiv').value = contenu.getAttribute("Email_Inter_Liv");

		document.getElementById('oebl-creation').setAttribute("label", "Exp\u00E9dition cr\u00E9\u00E9e le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Creation'));
		document.getElementById('oebl-modification').setAttribute("label", "Derni\u00E8re modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj'));
		document.getElementById('oebl-fiche').setAttribute("label", lblFiche +" N\u00B0 "+ contenu.getAttribute('Numero_BL'));
		document.getElementById('oebl-creation').collapsed = false;
		document.getElementById('oebl-modification').collapsed = false;

		document.getElementById('oebl-bOuvrirCommentairesCaches').disabled = false;

		document.getElementById('oebl-chkBonChiffre').checked = (isEmpty(oebl_clientId)?oebl_bonChiffre:contenu.getAttribute("Bon_Chiffre")=="true");
		document.getElementById('oebl-indications').value = contenu.getAttribute("Indications");

		oebl_aLiensColis.setParam("Bon_Id", bonId);
		oebl_aLiensColis.initTree();

		if (refreshArbres) oebl_aBon.initTree();

		oebl_aCom.setParam("Depot_Id", contenu.getAttribute("Depot_Id"));

		oebl_setModified(false);
		if (oebl_etatBon!='V' && oebl_etatBon!='A') {
			oebl_aCom.setParam('Commande_Id', commandeId);
			if (refreshArbres) {
				oebl_aCom.initTree(oebl_debloquerChamps);
			}
			else {
				oebl_debloquerChamps();
			}
			document.getElementById('oebl-bToutEnlever').disabled = false;
		}
		oebl_afficherColonnesFourn();

		if (oebl_specHMBEP && oebl_etatBon=='V' && (oebl_statutExpedition=='P' || (oebl_statutExpedition=='C' && oebl_typeExpedition=='F'))) {
			document.getElementById('oebl-bEnregistrer').disabled = false;
			document.getElementById('oebl-dateExpedition').disabled = false;
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_editerCommentairesInternes()  {
  try {

  	var url = "chrome://opensi/content/facturation/user/commun/popup-commentairesInternes.xul";
  	window.openDialog(url,'','chrome,modal,centerscreen', "BL", bonId, gReadOnly);

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_editerCommentairesDocument() {
  try {

		var commentairesFin = document.getElementById('oebl-commentairesFin').value;
		var commentairesInt = document.getElementById('oebl-commentairesInt').value;
		var readOnly = (oebl_etatBon!="N" || gReadOnly);

		var url = "chrome://opensi/content/facturation/user/commun/popup-commentairesDocument.xul";
  	window.openDialog(url,'','chrome,modal,centerscreen', oebl_retourEditerCommentaires, "BL", bonId, commentairesFin, commentairesInt, readOnly);

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_retourEditerCommentaires(commentairesFin, commentairesInt) {
  try {

		document.getElementById('oebl-commentairesFin').value = commentairesFin;
		document.getElementById('oebl-commentairesInt').value = commentairesInt;

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_enregistrerBon(rafraichir, noRefreshArbres) {
  try {

  	var ok = false;

		var oebl_qBonLivraison;

		if (oebl_mode=="C") {
			oebl_qBonLivraison = new QueryHttp("Facturation/Affaires/creerBonLivraison.tmpl");
			oebl_qBonLivraison.setParam("Commande_Id", commandeId);
			oebl_qBonLivraison.setParam("Type_Liv", oebl_typeExpedition);
		}
		else {
			oebl_qBonLivraison = new QueryHttp("Facturation/Affaires/modifierBonLivraison.tmpl");
			oebl_qBonLivraison.setParam("Bon_Id", bonId);
		}

		var oebl_modeExpedition = document.getElementById('oebl-modeExpedition').value;
		var oebl_pointRetrait = document.getElementById('oebl-pointRetrait').value;
		var oebl_dateExpedition = document.getElementById('oebl-dateExpedition').value;
		var oebl_consignesLiv = document.getElementById('oebl-consignesLiv').value;

		var oebl_denominationLiv = document.getElementById('oebl-denominationLiv').value;
		var oebl_adresse1Liv = document.getElementById('oebl-adresse1Liv').value;
		var oebl_adresse2Liv = document.getElementById('oebl-adresse2Liv').value;
		var oebl_adresse3Liv = document.getElementById('oebl-adresse3Liv').value;
		var oebl_codePostalLiv = document.getElementById('oebl-codePostalLiv').value;
		var oebl_villeLiv = document.getElementById('oebl-villeLiv').value;
		var oebl_codePaysLiv = document.getElementById('oebl-codePaysLiv').value;

		var oebl_civInterLiv = document.getElementById('oebl-civInterLiv').value;
		var oebl_nomInterLiv = document.getElementById('oebl-nomInterLiv').value;
		var oebl_prenomInterLiv = document.getElementById('oebl-prenomInterLiv').value;
		var oebl_telInter1Liv = document.getElementById('oebl-telInter1Liv').value;
		var oebl_telInter2Liv = document.getElementById('oebl-telInter2Liv').value;
		var oebl_faxInterLiv = document.getElementById('oebl-faxInterLiv').value;
		var oebl_emailInterLiv = document.getElementById('oebl-emailInterLiv').value;

		var oebl_nbColis = document.getElementById('oebl-nbColis').value;
		var nbPalettes = document.getElementById('oebl-nbPalettes').value;
		var oebl_fraisSup = document.getElementById('oebl-fraisSup').value;
		var oebl_commentairesFin = document.getElementById('oebl-commentairesFin').value;
		var oebl_commentairesInt = document.getElementById('oebl-commentairesInt').value;
		var oebl_depot = document.getElementById('oebl-depot').value;

		if (isEmpty(nbPalettes)) nbPalettes = 0;

		if (isEmpty(oebl_denominationLiv)) { showWarning("Veuillez indiquer la d\u00E9nomination du client de livraison !"); }
		else if (isEmpty(oebl_adresse1Liv)) { showWarning("Veuillez indiquer l'adresse du client de livraison !"); }
		else if (isEmpty(oebl_villeLiv)) { showWarning("Veuillez indiquer la ville du client de livraison !"); }
		else if (!isEmpty(oebl_telInter1Liv) && !isPhone(oebl_telInter1Liv)) { showWarning("T\u00E9l\u00E9phone 1 de livraison incorrect !"); }
		else if (!isEmpty(oebl_telInter2Liv) && !isPhone(oebl_telInter2Liv)) { showWarning("T\u00E9l\u00E9phone 2 de livraison incorrect !"); }
		else if (gShowFax && !isEmpty(oebl_faxInterLiv) && !isPhone(oebl_faxInterLiv)) { showWarning("Num\u00E9ro de fax de livraison incorrect !"); }
		else if (!isEmpty(oebl_emailInterLiv) && !isEmail(oebl_emailInterLiv)) { showWarning("Adresse e-mail de livraison incorrecte !"); }
		else if (!isEmpty(oebl_nbColis) && !isPositiveOrNullInteger(oebl_nbColis)) { showWarning("Nombre de colis incorrect !"); }
		else if (!isPositiveOrNullInteger(nbPalettes)) { showWarning("Nombre de palettes incorrect !"); }
		else if (isEmpty(oebl_fraisSup) || !isPositiveOrNull(oebl_fraisSup)) { showWarning("Frais de port suppl\u00E9mentaires incorrects !"); }
		else if (!isEmpty(oebl_consignesLiv) && oebl_consignesLiv.length>100) { showWarning("Consignes de livraison incorrectes (longueur max = 100 caract\u00E8res) !"); }
		else if (oebl_typeExpedition!="F" && isEmpty(oebl_depot)) { showWarning("Veuillez choisir un d\u00E9p\u00F4t d'exp\u00E9dition."); }
		else if (!isEmpty(oebl_dateExpedition) && !isDate(oebl_dateExpedition)) { showWarning("Date d'exp\u00E9dition pr\u00E9vue incorrecte"); }
		else {

			oebl_qBonLivraison.setParam("Mode_Expedition",oebl_modeExpedition);
			oebl_qBonLivraison.setParam("Consignes_Liv", oebl_consignesLiv);
			oebl_qBonLivraison.setParam("Point_Retrait", oebl_pointRetrait);
			oebl_qBonLivraison.setParam("Date_Expedition", oebl_dateExpedition);
			oebl_qBonLivraison.setParam("Denomination_Liv",oebl_denominationLiv);
			oebl_qBonLivraison.setParam("Adresse_1_Liv",oebl_adresse1Liv);
			oebl_qBonLivraison.setParam("Adresse_2_Liv",oebl_adresse2Liv);
			oebl_qBonLivraison.setParam("Adresse_3_Liv",oebl_adresse3Liv);
			oebl_qBonLivraison.setParam("Code_Postal_Liv",oebl_codePostalLiv);
			oebl_qBonLivraison.setParam("Ville_Liv",oebl_villeLiv);
			oebl_qBonLivraison.setParam("Code_Pays_Liv",oebl_codePaysLiv);
			oebl_qBonLivraison.setParam("Civ_Inter_Liv",oebl_civInterLiv);
			oebl_qBonLivraison.setParam("Nom_Inter_Liv",oebl_nomInterLiv);
			oebl_qBonLivraison.setParam("Prenom_Inter_Liv",oebl_prenomInterLiv);
			oebl_qBonLivraison.setParam("Tel_Inter_1_Liv",oebl_telInter1Liv);
			oebl_qBonLivraison.setParam("Tel_Inter_2_Liv",oebl_telInter2Liv);
			oebl_qBonLivraison.setParam("Fax_Inter_Liv",oebl_faxInterLiv);
			oebl_qBonLivraison.setParam("Email_Inter_Liv",oebl_emailInterLiv);
			oebl_qBonLivraison.setParam("Commentaires_Fin",oebl_commentairesFin);
			oebl_qBonLivraison.setParam("Commentaires_Int",oebl_commentairesInt);
			oebl_qBonLivraison.setParam("Nb_Palettes", nbPalettes);
			oebl_qBonLivraison.setParam("Frais_Sup",oebl_fraisSup);
			oebl_qBonLivraison.setParam("Fournisseur_Id",oebl_fournisseurId);
			oebl_qBonLivraison.setParam("Depot_Id",oebl_depot);

			var result = oebl_qBonLivraison.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}
			else {
				if (oebl_mode=="C") {
					bonId = result.responseXML.documentElement.getAttribute("Bon_Id");
					if (rafraichir) { oebl_chargerBon(noRefreshArbres==true); }
				}

				oebl_setModified(false);
				ok = true;
			}
		}

		return ok;

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_supprimerBon() {
  try {

		if (window.confirm("Confirmez-vous la suppression de cette exp\u00E9dition ?")) {

			oebl_qSupBL.setParam("Bon_Id", bonId);
			var result = oebl_qSupBL.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}
			else {
				showMessage("L'exp\u00E9dition a \u00E9t\u00E9 supprim\u00E9e avec succ\u00E8s !");
			}

			retourFicheAffaire();
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_generateBL() {
  try {

		var msgConfirm = "Confirmez-vous la g\u00E9n\u00E9ration du bon de livraison ?\n(Attention le bon de livraison valid\u00E9 ne pourra plus \u00EAtre modifi\u00E9 !)";
		if (oebl_typeExpedition=="F") {
			msgConfirm = "Confirmez-vous la g\u00E9n\u00E9ration de la commande fournisseur ?\n(Attention la commande valid\u00E9e ne pourra plus \u00EAtre modifi\u00E9e !)";
		}
		else if (oebl_typeExpedition=="L") {
			if (oebl_statutExpedition=="P") {
				msgConfirm = "Confirmez-vous la pr\u00E9paration de l'ordre de livraison ?";
			}
			else {
				msgConfirm = "Confirmez-vous la g\u00E9n\u00E9ration de l'ordre de livraison ?\n(Attention l'ordre de livraison valid\u00E9 ne pourra plus \u00EAtre modifi\u00E9 !)";
			}
		}

		if (oebl_aBon.nbLignes()<=0) {
			showWarning("L'exp\u00E9dition ne contient aucune ligne !");
		}
		else if (window.confirm(msgConfirm)) {

			var ok = true;

			if (oebl_actSuiviSerie && oebl_typeExpedition=="B") {
				var qCheck = new QueryHttp("Facturation/Affaires/checkNumSerieBL.tmpl");
				qCheck.setParam("Bon_Id", bonId);
				var result = qCheck.execute();

				var errors = new Errors(result);
				if (errors.hasNext()) {
					errors.show();
					ok = false;
				}
			}

			if (oebl_statutExpedition!="P") {

				if (ok && oebl_actSuiviLot) {
					var qCheck = new QueryHttp("Facturation/Affaires/checkNumLotBL.tmpl");
					qCheck.setParam("Bon_Id", bonId);
					var result = qCheck.execute();

					var errors = new Errors(result);
					if (errors.hasNext()) {
						errors.show();
						ok = false;
					}
				}

				if (ok) {
					var qValider = new QueryHttp("Facturation/Affaires/validerBonLivraison.tmpl");
					qValider.setParam('Bon_Id', bonId);
					qValider.setParam('Commande_Id', commandeId);
					qValider.setParam('Solder', document.getElementById('oebl-solder').checked);
					qValider.setParam('Nb_Colis', document.getElementById('oebl-nbColis').value);
					var result = qValider.execute();

					var errors = new Errors(result);
					if (errors.hasNext()) {
						errors.show();
						ok = false;
					}
				}
			}

			if (ok) {
				var qGenBL = new QueryHttp("Facturation/Affaires/generateBonLivraison.tmpl");
				qGenBL.setParam("Bon_Id", bonId);
				qGenBL.setParam("Envoi_Trans", document.getElementById('oebl-envoiTrans').checked);
				var result = qGenBL.execute();

				var errors = new Errors(result);
				if (errors.hasNext()) {
					errors.show();
				}
				else {
					oebl_chargerBon();
					oebl_chargerPdfBL();
				}
			}
  	}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_confirmerExpedition() {
  try {

  	if (window.confirm("Confirmez-vous l'exp\u00E9dition ?")) {

			var qConfExpe = new QueryHttp("Facturation/Affaires/confirmExpedition.tmpl");
			qConfExpe.setParam("Bon_Id", bonId);
			var result = qConfExpe.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}
			else {
				oebl_chargerBon();
			}
  	}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_toutTransferer() {
  try {

  	var ok = true;
		if (oebl_mode=="C") {
			ok = oebl_enregistrerBon(true, true);
		}
		if (ok) {
			oebl_qAjouterToutBon.setParam('Fournisseur_Id', oebl_fournisseurId);
			oebl_qAjouterToutBon.setParam("Bon_Id", bonId);
			oebl_qAjouterToutBon.setParam("Commande_Id", commandeId);
			var result = oebl_qAjouterToutBon.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}

			oebl_aCom.initTree();
			oebl_aBon.initTree();
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_toutTransfererDispo() {
  try {

  	var ok = true;
		if (oebl_mode=="C") {
			ok = oebl_enregistrerBon(true, true);
		}
		if (ok) {
			oebl_qAjouterToutBonDispo.setParam("Bon_Id", bonId);
			oebl_qAjouterToutBonDispo.setParam("Commande_Id", commandeId);
			var result = oebl_qAjouterToutBonDispo.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}

			oebl_aCom.initTree();
			oebl_aBon.initTree();
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_toutEnlever() {
  try {

		oebl_qEnleverToutBon.setParam("Bon_Id", bonId);
		var result = oebl_qEnleverToutBon.execute();

		var errors = new Errors(result);
		if (errors.hasNext()) {
			errors.show();
		}
		else {
			oebl_aCom.initTree();
			oebl_aBon.initTree();
			document.getElementById("oebl-bConsultSerieLigne").disabled = true;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_ajouter() {
  try {

		if (oebl_aCom.isSelected()) {

			var articleId = oebl_aCom.getSelectedCellText('oebl-colArticleIdDev');
			var ligneCC = oebl_aCom.getSelectedCellText('oebl-colLigneIdDev');
			var isSuiviLot = oebl_aCom.getSelectedCellText('oebl-colSuiviLotDev')=="true" && !oebl_specHMLBP;
			var isSuiviDLC = oebl_aCom.getSelectedCellText('oebl-colSuiviDLCDev')=="true" && !oebl_specHMLBP;
			var isSuiviSerie = oebl_aCom.getSelectedCellText('oebl-colSuiviSerieDev')=="true";
			var qteRestante = oebl_aCom.getSelectedCellText('oebl-colQuantiteDev');
			var quantiteMax = oebl_aCom.getSelectedCellText('oebl-colQteMaxDev');
			var nbPiecesRestant = oebl_aCom.getSelectedCellText('oebl-colNbPiecesDev');
			if (isEmpty(nbPiecesRestant)) { nbPiecesRestant = 0; }

			var quantite = document.getElementById('oebl-quantite').value;
			var numLot = document.getElementById('oebl-numLot').value;
			var datePeremption = document.getElementById('oebl-datePeremption').value;
			var nbPieces = document.getElementById('oebl-nbPieces').value;
			if (isEmpty(nbPieces)) { nbPieces = 0; }

			if (isEmpty(quantite)) { showWarning("Veuillez entrer une quantit\u00E9 \u00E0 transf\u00E9rer !"); }
			else if (!checkQte(quantite)) { showWarning("Quantit\u00E9 incorrecte !"); }
			else if (!isPositiveOrNullInteger(nbPieces)) { showWarning("Nombre de pi\u00E8ces incorrect");	}
			else if (oebl_bloquerBLSansStock && oebl_typeExpedition!="F" && !isEmpty(articleId) && parseFloat(quantite)>parseFloat(quantiteMax)) { showWarning("Quantit\u00E9 en stock insuffisante (max: "+ quantiteMax +")"); }
			else if (oebl_checkNumLotLigne(numLot, datePeremption, articleId, isSuiviLot, isSuiviDLC)) {

				var continuer = true;

				if (parseFloat(qteRestante)-parseFloat(quantite)<0) {
					continuer = window.confirm("La quantit\u00E9 \u00E0 transf\u00E9rer d\u00E9passe la quantit\u00E9 restant \u00E0 livrer !\n\nVoulez-vous vraiment livrer plus que la quantit\u00E9 command\u00E9e ?");
				}

				if (parseFloat(nbPiecesRestant)-parseFloat(nbPieces)<0) {
					continuer = window.confirm("Le nb de pi\u00E8ces \u00E0 transf\u00E9rer d\u00E9passe le nb de pi\u00E8ces restant \u00E0 livrer !\n\nVoulez-vous vraiment livrer plus que le nb de pi\u00E8ces command\u00E9 ?");
				}

				if (continuer) {

					var ok = true;

					if (oebl_mode=="C") {
						ok = oebl_enregistrerBon(true, true);
					}

					if (ok) {
						var qAdd = new QueryHttp('Facturation/Affaires/addLigneBL.tmpl');
						qAdd.setParam("Bon_Id", bonId);
						qAdd.setParam("Ligne_CC", ligneCC);
						qAdd.setParam("Quantite", quantite);
						qAdd.setParam("Num_Lot", numLot);
						qAdd.setParam("Nb_Pieces", nbPieces);
						qAdd.setParam("Date_Peremption", datePeremption);
						var result = qAdd.execute();

						var errors = new Errors(result);
						if (errors.hasNext()) {
							errors.show();
						}
						else {
							var ligneBL = result.responseXML.documentElement.getAttribute('Ligne_Id');
							var quantiteBL = parseIntBis(result.responseXML.documentElement.getAttribute('Quantite'));

							if (!oebl_etapePrepaBL && oebl_typeExpedition=="B") {
								oebl_checkNumSerieLigne(ligneBL, isSuiviSerie, quantiteBL);
							}
						}

						oebl_aCom.initTree();
						oebl_aBon.initTree();
						oebl_disableAjouter(true,false);
					}
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_ajouterSelection(listLigneId) {
  try {

		var ok = true;
		if (oebl_mode=="C") {
			ok = oebl_enregistrerBon(true, true);
		}
		if (ok) {
			oebl_qAjouterToutBon.setParam('Fournisseur_Id', oebl_fournisseurId);
			oebl_qAjouterToutBon.setParam("Bon_Id", bonId);
			oebl_qAjouterToutBon.setParam("Commande_Id", commandeId);
			oebl_qAjouterToutBon.setParam("List_Ligne_Id", listLigneId);
			var result = oebl_qAjouterToutBon.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}

			oebl_aCom.initTree();
			oebl_aBon.initTree();
			//oebl_disableAjouter(true,false); // utile au passage de l'ihm en multi-slection de lignes
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_enlever() {
  try {

		if (oebl_aBon.isSelected()) {
			var oebl_ligneId = oebl_aBon.getSelectedCellText('oebl-colLigneIdLiv');
			var oebl_qteInit = oebl_aBon.getSelectedCellText('oebl-colQuantiteLiv');
			var oebl_quantite = document.getElementById('oebl-quantite').value;
			var oebl_nbPiecesInit = oebl_aBon.getSelectedCellText('oebl-colNbPiecesLiv');
			if (isEmpty(oebl_nbPiecesInit)) { oebl_nbPiecesInit = 0; }
			var oebl_nbPieces = document.getElementById('oebl-nbPieces').value;
			if (isEmpty(oebl_nbPieces)) {
				oebl_nbPieces = 0;
			}

			if (isEmpty(oebl_quantite)) {
				showWarning("Veuillez entrer une quantit\u00E9 \u00E0 enlever !");
			}
			else if (!checkQte(oebl_quantite)) {
				showWarning("Quantit\u00E9 incorrecte !");
			}
			else if (parseFloat(oebl_qteInit)-parseFloat(oebl_quantite)<0) {
				showWarning("La quantit\u00E9 \u00E0 enlever ne peut d\u00E9passer la quantit\u00E9 pr\u00E9sente dans l'exp\u00E9dition !");
			}
			else if (!isPositiveOrNullInteger(oebl_nbPieces)) { showWarning("Nombre de pi\u00E8ces incorrect !");	}
			else if (parseFloat(oebl_nbPiecesInit)-parseFloat(oebl_nbPieces)<0) {
				showWarning("Le nb de pi\u00E8ces \u00E0 enlever ne peut d\u00E9passer le nb de pi\u00E8ces pr\u00E9sent dans l'exp\u00E9dition !");
			}
			else {
				oebl_qEnleverArticles.setParam("Ligne_Id", oebl_ligneId);
				oebl_qEnleverArticles.setParam("Quantite", oebl_quantite);
				oebl_qEnleverArticles.setParam("Nb_Pieces", oebl_nbPieces);
				var result = oebl_qEnleverArticles.execute();

				var errors = new Errors(result);
				if (errors.hasNext()) {
					errors.show();
				}

				oebl_aCom.initTree();
				oebl_aBon.initTree();

				oebl_disableEnlever(true,false);
				document.getElementById("oebl-bConsultSerieLigne").disabled = true;
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_demandeEnregistrement() {
  try {

		if (oebl_modified) {
			if (window.confirm("Voulez-vous enregistrer les modifications apport\u00E9es \u00E0 l'exp\u00E9dition ?")) {
				oebl_enregistrerBon(false);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_setModified(m) {
  try {

  	oebl_modified = m && !gReadOnly;

		if (oebl_modified) {
			document.getElementById('oebl-tabBon').setAttribute('image', 'chrome://opensi/content/design/icones/modified.png');
			document.getElementById('oebl-bGenerateBP').disabled = true;
			document.getElementById('oebl-bGenerateBL').disabled = true;
			document.getElementById('oebl-bEditionBL').disabled = true;
			document.getElementById('oebl-bColisage').disabled = true;
			document.getElementById('oebl-bEditionBP').disabled = true;
		}
		else {
			document.getElementById('oebl-tabBon').setAttribute('image', gReadOnly?'chrome://opensi/content/design/icones/readonly.png':null);
			document.getElementById('oebl-bGenerateBP').disabled = (oebl_etatBon=='V');
			document.getElementById('oebl-bGenerateBP').collapsed = oebl_mode=='C' || (!oebl_etapePrepaBL && oebl_typeExpedition=="B") || (!oebl_etapePrepaOL && oebl_typeExpedition=="L") || (!oebl_etapePrepaLF && oebl_typeExpedition=="F") || oebl_etatBon!='N' || (gReadOnly && !gProfil.isValidationBP());
			document.getElementById('oebl-bGenerateBL').disabled = false;
			document.getElementById('oebl-bGenerateBL').collapsed = oebl_mode=='C' || (oebl_statutExpedition!='P' && ((oebl_etapePrepaBL && oebl_typeExpedition=="B") || (oebl_etapePrepaOL && oebl_typeExpedition=="L") || (oebl_etapePrepaLF && oebl_typeExpedition=="F") || oebl_etatBon!='N')) || (gReadOnly && !gProfil.isValidationBL());
			document.getElementById('oebl-bEditionBL').disabled = false;
			document.getElementById('oebl-bEditionBL').collapsed = (oebl_etatBon=='N' || (oebl_typeExpedition=="B" && (oebl_statutExpedition=='P' || isEmpty(document.getElementById('oebl-dateBL').value))));
			document.getElementById('oebl-bColisage').disabled = (oebl_etatBon=='N' || oebl_etatBon=='A');
			document.getElementById('oebl-bEditionBP').disabled = false;
			document.getElementById('oebl-bEditionBP').collapsed = (oebl_etatBon=='N' || oebl_typeExpedition!='B');
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oebl_chargerPdfBL() {
  try {

		var qLangueDefaut = new QueryHttp("Facturation/Commun/getLangueDefaut.tmpl");
		qLangueDefaut.setParam("Type_Doc", "BL");
		qLangueDefaut.setParam("Doc_Id", bonId);
		var result = qLangueDefaut.execute();
		oebl_langueDefaut = result.responseXML.documentElement.getAttribute("Langue_Id");

		oebl_aLangues.setParam("Selection", oebl_langueDefaut);
		oebl_aLangues.initTree(oebl_initLangue);

  } catch (e) {
    recup_erreur(e);
  }
}


function oebl_initLangue() {
	try {

		document.getElementById('oebl-langueDefaut').value = oebl_langueDefaut;
		oebl_editerBon();

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_editerBP() {
	try {

		document.getElementById("oebl-barEdition").collapsed = true;
		document.getElementById('oebl-pdfBonLivraison').setAttribute("src", "");
		document.getElementById("bRetourExpedition").collapsed = false;
		document.getElementById("oebl-deckBonLivraison").selectedIndex = 1;
		document.getElementById('oebl-bEnvoyer').collapsed = true;
		document.getElementById('oebl-chkEditBP').collapsed = true;

		var oebl_qGenPdf = new QueryHttp("Facturation/Affaires/pdfBonPreparation.tmpl");
		oebl_qGenPdf.setParam('Bon_Id', bonId);

		var result = oebl_qGenPdf.execute();
		var page = getDirPdf() + result.responseXML.documentElement.getAttribute('FichierPDF');

		document.getElementById('oebl-pdfBonLivraison').setAttribute("src", page);

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_editerBon() {
	try {

		document.getElementById("oebl-barEdition").collapsed = (oebl_typeExpedition!="B");
		document.getElementById('oebl-pdfBonLivraison').setAttribute("src", "");
		document.getElementById("bRetourExpedition").collapsed = false;
		document.getElementById("oebl-deckBonLivraison").selectedIndex = 1;
		document.getElementById('oebl-chkBonChiffre').collapsed = (oebl_typeExpedition=="L");
		document.getElementById('oebl-chkCFChiffre').collapsed = (oebl_typeExpedition!="F");
		document.getElementById('oebl-bEnvoyer').collapsed = false;
		document.getElementById('oebl-boxLangue').collapsed = (oebl_typeExpedition!="B");
		document.getElementById('oebl-chkEditBP').collapsed = (oebl_typeExpedition!="B");
		document.getElementById('oebl-chkEditCF').collapsed = (oebl_typeExpedition!="F");
		document.getElementById('oebl-chkEditLF').collapsed = (oebl_typeExpedition!="F");

		var editBP = document.getElementById('oebl-chkEditBP').checked;
		var editCF = document.getElementById('oebl-chkEditCF').checked;
		var editLF = document.getElementById('oebl-chkEditLF').checked;
		var typeDoc = (oebl_typeExpedition=="B"?"BL":oebl_typeExpedition=="L"?"OL":"LF");
		var langue = (oebl_typeExpedition=="F"?"0":document.getElementById('oebl-langueDefaut').value);
		var showTotaux = document.getElementById('oebl-chkBonChiffre').checked;
		var showTotauxCF = document.getElementById('oebl-chkCFChiffre').checked;

		if (oebl_typeExpedition=="F" && !editCF && !editLF) {
			showWarning("Vous devez cocher au moins une des deux cases 'Editer la commande fournisseur' ou 'Editer le bon de livraison'");
		}
		else {
			var oebl_qGenPdf = new QueryHttp("Facturation/Affaires/pdfBonLivraison.tmpl");
			oebl_qGenPdf.setParam('Bon_Id', bonId);
	  	oebl_qGenPdf.setParam("Edit_BP", editBP);
	  	oebl_qGenPdf.setParam("Edit_LF", editLF);
	  	oebl_qGenPdf.setParam("Edit_CF", editCF);
	  	oebl_qGenPdf.setParam('Langue', langue);
			oebl_qGenPdf.setParam('Show_Totaux', showTotaux);
			oebl_qGenPdf.setParam('Show_Totaux_CF', showTotauxCF);
			oebl_qGenPdf.setParam("Type_Doc", typeDoc);

			var result = oebl_qGenPdf.execute();
			var page = getDirPdf() + result.responseXML.documentElement.getAttribute('FichierPDF');

			document.getElementById('oebl-pdfBonLivraison').setAttribute("src", page);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_validerBon() {
  try {

		if (oebl_aBon.nbLignes()<=0) {
			showWarning("L'exp\u00E9dition ne contient aucune ligne !");
		}
		else {
			var ok = true;

			if (oebl_actSuiviLot) {
				var qCheck = new QueryHttp("Facturation/Affaires/checkNumLotBL.tmpl");
				qCheck.setParam("Bon_Id", bonId);
				var result = qCheck.execute();

				var errors = new Errors(result);
				if (errors.hasNext()) {
					errors.show();
					ok = false;
				}
			}

			var msgconfirm = "";

			if (gConfig.isGACAlerteNPBP() && oebl_nonPaye) {
				msgconfirm = "ATTENTION : La commande n'est pas pay\u00E9e !\n";
			}

			msgconfirm += "Confirmez-vous la g\u00E9n\u00E9ration du bon de pr\u00E9paration ?";
			if (oebl_typeExpedition=="F") {
				msgconfirm += "Confirmez-vous la g\u00E9n\u00E9ration de la commande fournisseur ?\n(Attention la commande valid\u00E9e ne pourra plus \u00EAtre modifi\u00E9e !)";
			}
			else if (oebl_typeExpedition=="L") {
				msgconfirm += "Confirmez-vous la g\u00E9n\u00E9ration de l'ordre de livraison ?\n(Attention l'ordre de livraison valid\u00E9 ne pourra plus \u00EAtre modifi\u00E9 !)";
			}

			if (ok && window.confirm(msgconfirm)) {

				var qValider = new QueryHttp("Facturation/Affaires/validerBonLivraison.tmpl");
				qValider.setParam('Bon_Id', bonId);
				qValider.setParam('Commande_Id', commandeId);
				qValider.setParam('Solder', document.getElementById('oebl-solder').checked);
				qValider.setParam('Nb_Colis', document.getElementById('oebl-nbColis').value);
				var result = qValider.execute();

				var errors = new Errors(result);
				if (errors.hasNext()) {
					errors.show();
				}
				else {
					oebl_chargerBon();
					if (oebl_typeExpedition=="B") {
						oebl_editerBP();
					}
					else {
						oebl_chargerPdfBL();
					}
				}
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_annulerBon() {
  try {

		document.getElementById('oebl-bAnnuler').disabled = true;

		if (window.confirm("Confirmez-vous l'annulation de l'exp\u00E9dition ?"+ (oebl_typeExpedition=="F"?"\nAttention la commande fournisseur correspondant au LF va \u00E9galement \u00EAtre annul\u00E9e":""))) {

			oebl_qAnnuler.setParam('Bon_Id', bonId);
			var result = oebl_qAnnuler.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}
			else {
				showMessage("L'exp\u00E9dition a \u00E9t\u00E9 annul\u00E9e !");
			}
			oebl_chargerBon();
		}
		else {
			document.getElementById('oebl-bAnnuler').disabled = false;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_rechercherAdrLiv() {
  try {

  	oebl_currentCodePaysLiv = document.getElementById('oebl-codePaysLiv').value;

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixAdresse.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', oebl_reporterAdrLiv, oebl_clientId, gReadOnly);

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_reporterAdrLiv(nom, adr1, adr2, adr3, cp, ville, pays, code_pays, contact_fact, contact_liv, contact_envoi, contact_devis, adresseId) {
  try {

		var qGet = new QueryHttp("Facturation/Affaires/getInfosCommandeClient.tmpl");
		qGet.setParam("Commande_Id", commandeId);
		var result = qGet.execute();

	  var assujettiTVA = result.responseXML.documentElement.getAttribute("Assujetti_TVA")=="true";

  	if (oebl_currentCodePaysLiv!=code_pays && !assujettiTVA) {
  		showWarning("L'adresse choisie doit \u00EAtre dans le m\u00EAme pays que le pays de livraison actuel !");
  	}
		else {
			document.getElementById('oebl-denominationLiv').value = nom;
			document.getElementById('oebl-adresse1Liv').value = adr1;
			document.getElementById('oebl-adresse2Liv').value = adr2;
			document.getElementById('oebl-adresse3Liv').value = adr3;
			document.getElementById('oebl-codePostalLiv').value = cp;
			document.getElementById('oebl-villeLiv').value = ville;
		  document.getElementById('oebl-codePaysLiv').value = code_pays;

			if (!isEmpty(contact_liv)) {
				var qLoad = new QueryHttp("Facturation/Clients/loadContactClient.tmpl");
		  	qLoad.setParam("Contact_Id", contact_liv);
		  	var result = qLoad.execute();
		  	var contenu = result.responseXML.documentElement;
		  	oebl_reporterInterLiv(contenu.getAttribute("Civilite"),contenu.getAttribute("Nom"),contenu.getAttribute("Prenom"),contenu.getAttribute("Tel_1"),contenu.getAttribute("Tel_2"),contenu.getAttribute("Fax"),contenu.getAttribute("Email"));
		  }
			else {
				oebl_setModified(true);
		  }
  	}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_rechercherInterlocuteurLiv() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixInter.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', oebl_reporterInterLiv, oebl_clientId, false);

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_reporterInterLiv(civ, nom, prenom, tel1, tel2, fax, email) {
  try {

		document.getElementById('oebl-civInterLiv').value = civ;
		document.getElementById('oebl-nomInterLiv').value = nom;
		document.getElementById('oebl-prenomInterLiv').value = prenom;
		document.getElementById('oebl-telInter1Liv').value = tel1;
		document.getElementById('oebl-telInter2Liv').value = tel2;
		document.getElementById('oebl-faxInterLiv').value = fax;
		document.getElementById('oebl-emailInterLiv').value = email;

		oebl_setModified(true);

	} catch (e) {
  	recup_erreur(e);
  }
}

function oebl_choisirMentions() {
  try {

  	var ok = true;

  	if (oebl_mode=="C") {
			ok = oebl_enregistrerBon(true);
		}

		if (ok) {
			var url = "chrome://opensi/content/facturation/user/commun/popup-mentionsDocument.xul";
	    window.openDialog(url,'','chrome,modal,centerscreen', "BL", bonId, gReadOnly);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_colisage() {
  try {

		oecol_init();
		document.getElementById("oecol-deckColisageEtiquettes").selectedIndex = 0;
		document.getElementById('bRetourExpedition').collapsed = false;
		document.getElementById("deck").selectedIndex = 4;

  } catch (e) {
    recup_erreur(e);
  }
}


function oebl_initVersion() {
	try {

		oebl_aVersion.setParam("Bon_Id", bonId);
		oebl_aVersion.initTree();

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_selectionLigneBL()  {
	try {

		oebl_reporterQteSortie();
		oebl_disableEnlever(false, true);
		oebl_disableAjouter(true, false);

		if (oebl_aBon.isSelected() && (oebl_mode=="M" || oebl_mode=="V")) {
			var articleId = oebl_aBon.getSelectedCellText('oebl-colArticleIdLiv');
			document.getElementById("oebl-bConsultSerieLigne").disabled = isEmpty(articleId);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_checkNumSerieLigne(ligneId, isSuiviSerie, quantite) {
	try {

		if (oebl_actSuiviSerie) {
			var qNbSerie = new QueryHttp("Facturation/Affaires/getNbNumSerieLigneBL.tmpl");
			qNbSerie.setParam("Ligne_Id", ligneId);
			var resNS = qNbSerie.execute();
			var nb = parseIntBis(resNS.responseXML.documentElement.getAttribute("Nombre"));
			if ((isSuiviSerie && nb!=quantite) || nb>quantite) {
				var depotId = document.getElementById('oebl-depot').value;
				var url = "chrome://opensi/content/facturation/user/commun/popup-numSerie.xul";
		    window.openDialog(url,'','chrome,modal,centerscreen', "S", "BL", ligneId, depotId);
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_consulterNumSerie()  {
	try {

		if (oebl_aBon.isSelected()) {
			var ligneId = oebl_aBon.getSelectedCellText('oebl-colLigneIdLiv');
			var mode = (oebl_etatBon=="A" || oebl_statutExpedition=="E" || oebl_statutExpedition=="C" || gReadOnly?"C":"S");
			var depotId = document.getElementById('oebl-depot').value;
			var url = "chrome://opensi/content/facturation/user/commun/popup-numSerie.xul";
   		window.openDialog(url,'','chrome,modal,centerscreen', mode, "BL", ligneId, depotId);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_checkNumLotLigne(numero, datePeremption, articleId, isSuiviLot, isSuiviDLC) {
	try {

		var ok = true;

		if (oebl_actSuiviLot && !isEmpty(articleId)) {

			if ((isSuiviLot || !isEmpty(datePeremption)) && isEmpty(numero)) {
				ok = false;
				showWarning("N\u00B0 Lot manquant");
			}
			else if (isSuiviDLC && isEmpty(datePeremption)) {
				ok = false;
				showWarning("Date de p\u00E9remption manquante");
			}
			else if (!isEmpty(datePeremption) && !isDate(datePeremption)) {
				ok = false;
				showWarning("Date de p\u00E9remption incorrecte");
			}
	    else if (!isEmpty(numero)) {
				var qLotBloque = new QueryHttp("Facturation/Tracabilite/isLotBloque.tmpl");
				qLotBloque.setParam("Num_Lot", numero);
				qLotBloque.setParam("Article_Id", articleId);
				var resLB = qLotBloque.execute();
				if (resLB.responseXML.documentElement.getAttribute("Bloque")=="true") {
					ok = false;
					showWarning("Impossible de valider la ligne : N\u00B0 Lot bloqu\u00E9");
				}
	    }
		}

		return ok;

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_pressOnNumLot(ev) {
	try {

		if (ev.keyCode==13 && oebl_aCom.isSelected()) {
			var articleId = oebl_aCom.getSelectedCellText('oebl-colArticleIdDev');
			var numero = document.getElementById("oebl-numLot").value;
			var depotId = document.getElementById('oebl-depot').value;

			if (!isEmpty(articleId)) {
				var url = "chrome://opensi/content/facturation/user/tracabilite_articles/popup-rechercheLot.xul";
				window.openDialog(url,'','chrome,modal,centerscreen', oebl_retourRechercherLot, articleId, numero, depotId, null);
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_retourRechercherLot(numero, datePeremption) {
	try {

		document.getElementById("oebl-numLot").value = numero;
		document.getElementById("oebl-datePeremption").value = datePeremption;

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_updateDLC() {
	try {

		if (oebl_aCom.isSelected()) {
			var numero = document.getElementById("oebl-numLot").value;
			var articleId = oebl_aCom.getSelectedCellText('oebl-colArticleIdDev');

			if (!isEmpty(numero) && !isEmpty(articleId)) {
				var qGetDLC = new QueryHttp("Facturation/Tracabilite/getDLCNumLot.tmpl");
				qGetDLC.setParam("Article_Id", articleId);
				qGetDLC.setParam("Numero", numero);
				var result = qGetDLC.execute();
				var datePeremption = result.responseXML.documentElement.getAttribute("Date_Peremption");
				if (!isEmpty(datePeremption)) {
					document.getElementById("oebl-datePeremption").value = datePeremption;
				}
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_selectionArticleCommande() {
	try {

		if (oebl_aCom.isSelected()) {
			oebl_reporterQteEntree();
			oebl_disableAjouter(false, true);
			oebl_disableEnlever(true, false);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_onKeyPressNumSerie(event) {
	try {

		if (event.keyCode==13) {
			oebl_validerSaisieBySerie();
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_validerSaisieBySerie(ligneId) {
	try {

		var listLigneCC = ligneId;

		if (listLigneCC==null) {
			listLigneCC = "";
			var nbLignes = oebl_aCom.nbLignes();
			for (i=0; i<nbLignes; i++) {
				if (parseFloat(oebl_aCom.getCellText(i, 'oebl-colQuantiteDev'))>0) {
					listLigneCC += oebl_aCom.getCellText(i, 'oebl-colLigneIdDev') +",";
				}
			}
		}

		var numSerie = document.getElementById("oebl-numSerie").value;

		if (!isEmpty(numSerie)) {

			var ok = true;
			if (oebl_mode=="C") {
				ok = oebl_enregistrerBon(true);
			}
			if (ok) {
				var qAjouterNumSerie = new QueryHttp('Facturation/Affaires/addNumSerieBL.tmpl');
				qAjouterNumSerie.setParam("Bon_Id", bonId);
				qAjouterNumSerie.setParam("Num_Serie", numSerie);
				qAjouterNumSerie.setParam("List_Ligne_CC", listLigneCC);
				var result = qAjouterNumSerie.execute();

				var errors = new Errors(result);
				if (errors.hasNext()) {
					errors.show();
				}
				else {
					var conflit = (result.responseXML.documentElement.getAttribute("Conflit")=="true");
					if (conflit) {
						var listConflit = result.responseXML.documentElement.getAttribute("List_Conflit");
						var url = "chrome://opensi/content/facturation/user/affaires/popup-conflitNumSerieCC.xul";
			      window.openDialog(url,'','chrome,modal,centerscreen', listConflit, oebl_retourChoixConflit);
					}
					else {
						oebl_aCom.initTree();
						oebl_aBon.initTree();
						document.getElementById("oebl-numSerie").value = "";
					}
				}
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_retourChoixConflit(ligneId) {
	try {

		oebl_validerSaisieBySerie(ligneId);

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_envoyerMail() {
	try {

		var typeDoc = (oebl_typeExpedition=="B"?"BL":oebl_typeExpedition=="L"?"OL":"LF");
		var langue = (oebl_typeExpedition=="F"?"0":document.getElementById('oebl-langueDefaut').value);
		var showTotaux = document.getElementById('oebl-chkBonChiffre').checked;
		var showTotauxCF = document.getElementById('oebl-chkCFChiffre').checked;
		var editBP = document.getElementById('oebl-chkEditBP').checked;
		var editCF = document.getElementById('oebl-chkEditCF').checked;
		var editLF = document.getElementById('oebl-chkEditLF').checked;

		if (oebl_typeExpedition=="F" && !editCF && !editLF) {
			showWarning("Vous devez cocher au moins une des deux cases 'Editer la commande fournisseur' ou 'Editer le bon de livraison'");
		}
		else {
			var url = "chrome://opensi/content/popup/popup-envoyerMail.xul";
			window.openDialog(url,'','chrome,modal,centerscreen', typeDoc, bonId, langue, showTotaux, (typeDoc=="LF"?showTotauxCF:editBP), editLF, editCF);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_editerPrixAchat() {
	try {

		if (oebl_typeExpedition=="F" && oebl_etatBon=="N" && !gReadOnly && gAccesCoutAchat && oebl_aBon.isSelected()) {
			var ligneId = oebl_aBon.getSelectedCellText('oebl-colLigneIdLiv');
			var prixAchat = oebl_aBon.getSelectedCellText('oebl-colPrixAchatCFLiv');

			var url = "chrome://opensi/content/facturation/user/affaires/popup-modifierPrixAchatBL.xul";
    	window.openDialog(url,'','chrome,modal,centerscreen', ligneId, prixAchat, oebl_retourEditerPrixAchat);
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_retourEditerPrixAchat() {
	try {

		oebl_aBon.initTree();

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_clickOnColis(tree, ev) {

	gClipboardHelper.copyString(oebl_aLiensColis.getSelectedCellText("oebl-colNumColis"));

	var col = oebl_aLiensColis.getClickedCol(ev);

	if (col!=null && col.id=="oebl-colNumColis") {
		var lien = oebl_aLiensColis.getSelectedCellValue("oebl-colNumColis");
		if (!isEmpty(lien)) {
			//window.open(lien);
			openInNavigator(lien);
		}
	}
	else if (col!=null && col.id=="oebl-colCTC") {
		window.open(oebl_aLiensColis.getSelectedCellValue("oebl-colCTC"));
	}
}


function oebl_keypressOnColis(ev) {
  try {

		if ((ev.key=='w' || ev.key=='W') && ev.ctrlKey && oebl_aLiensColis.isSelected()) {
			// ctrl + w pour copier l'adresse du lien
			gClipboardHelper.copyString(oebl_aLiensColis.getSelectedCellValue("oebl-colNumColis"));
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_initModePrepa() {
	try {

		oebl_etapePrepaBL = oebl_defautEtapePrepaBL;
		oebl_etapePrepaOL = oebl_defautEtapePrepaOL;

		if (!isEmpty(oebl_curDepot)) {
			var qDepot = new QueryHttp("Facturation/Commun/getDepotStock.tmpl");
			qDepot.setParam("Depot_Id", oebl_curDepot);
			var result = qDepot.execute();

			var etapePrepaDepotBL = result.responseXML.documentElement.getAttribute("Etape_Prepa_BL_CC");
			if (!isEmpty(etapePrepaDepotBL)) {
				oebl_etapePrepaBL = (etapePrepaDepotBL=="true");
				oebl_etapePrepaOL = (etapePrepaDepotBL=="true");
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function oebl_rechercherPointRelais() {
  try {

		oebl_currentCodePaysLiv = document.getElementById('oebl-codePaysLiv').value;
		var modeExpedition = document.getElementById('oebl-modeExpedition').value;

		if (isEmpty(modeExpedition)) {
			showWarning("Veuillez choisir un mode d'exp\u00E9dition pour acc\u00E9der aux points relais du transporteur");
		}
		else {
			var url = "chrome://opensi/content/facturation/user/commun/popup-recherchePointRelais.xul";
    	window.openDialog(url,'','chrome,modal,centerscreen', oebl_reporterPointRelais, modeExpedition, oebl_currentCodePaysLiv);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_reporterPointRelais(codeRelais, denomination, adresse1, adresse2, adresse3, codePostal, ville, codePays) {
  try {

		document.getElementById('oebl-pointRetrait').value = codeRelais;
		document.getElementById('oebl-tabBoxAdresses').selectedIndex = 1;
		oebl_reporterAdrLiv(denomination, adresse1, adresse2, adresse3, codePostal, ville, "", codePays, "", "", "", "", "");

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_pressOnColis() {
  try {

		if (oebl_aLiensColis.isSelected()) {
			document.getElementById('oebl-bAnnulerColis').disabled = (oebl_aLiensColis.getSelectedCellText("oebl-colStatut")!="V");
		}
		else {
			document.getElementById('oebl-bAnnulerColis').disabled = true;
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function oebl_annulerColis() {
  try {

		document.getElementById('oebl-bAnnulerColis').disabled = true;

		if (window.confirm("Confirmez-vous l'annulation du colis s\u00E9lectionn\u00E9 ?")) {

			var colisId = oebl_aLiensColis.getSelectedCellText("oebl-colColisId");

			var qCancel = new QueryHttp("Facturation/Affaires/cancelColis.tmpl");
			qCancel.setParam("Colis_Id", colisId);
			var result = qCancel.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}
			else {
				showMessage("Le colis a \u00E9t\u00E9 annul\u00E9");
			}
			oebl_aLiensColis.initTree();
		}
		else {
			document.getElementById('oebl-bAnnulerColis').disabled = false;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_editerColisageCSV() {
  try {

		var qEditionCsv = new QueryHttp("Facturation/Affaires/csvColisageBL.tmpl");
		qEditionCsv.setParam("Bon_Liv_Id", bonId);

		var result = qEditionCsv.execute();

		var errors = new Errors(result);
		if (errors.hasNext()) {
			errors.show();
		}
		else {
			var fichier = result.responseXML.documentElement.getAttribute('FichierCSV');
			var file = fileChooser("save", fichier);
			if (file!=null) {
				downloadFile(getDirBuffer()+ fichier, file);
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oebl_editerColisagePDF() {
  try {

		var qEditionPdf = new QueryHttp("Facturation/Affaires/pdfColisageBL.tmpl");
		qEditionPdf.setParam("Bon_Liv_Id", bonId);

		document.getElementById('oebl-deckBonLivraison').selectedIndex = 2;

		var result = qEditionPdf.execute();

		var errors = new Errors(result);
		if (errors.hasNext()) {
			errors.show();
		}
		else {
			var page = getDirPdf() + result.responseXML.documentElement.getAttribute('FichierPDF');
			document.getElementById('oebl-pdfEdition').setAttribute("src", page);

			document.getElementById('bRetourExpedition').collapsed = false;
		}

	} catch (e) {
    recup_erreur(e);
  }
}
