/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

/*
 * bibliothque de fonctions pour la gestion de semaphores synchronisant l'initialisation d'arbres RDF.
 *
 * charger util.js pralablement
 * SyncInitArbre ne fonctionne qu'avec des arbres : charger arbres.js pralablement
 */
function demandeRdv(sema) {
	sema.params[0].rdv();
}

function SyncInitArbre(ftoexec) {
	this.count = 0;
	this.ftoexec = ftoexec;
	this.tarbre = new Array();
}

SyncInitArbre.prototype.add = function(arbre) {
	this.tarbre.push(arbre);
	this.count++;
}

SyncInitArbre.prototype.load = function() {
	for (var i=0; i<this.tarbre.length; i++) {
		var tabParam = new Array(this);
		this.tarbre[i].initTree(demandeRdv, tabParam);
	}
}

SyncInitArbre.prototype.rdv = function() {
	this.count--;
	if (this.count==0) {
		this.ftoexec();
	}
}
