/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
var aListePaysBL=new Arbre("Facturation/Affaires/liste-paysBL.tmpl","bons");

function init() {
  try {

    window.resizeTo(500,350);

    init_tree();

  } catch (e) {
    recup_erreur(e);
  }
}


function ouvrirPays() {
  try {

		if (aListePaysBL.isSelected()) {

    	window.arguments[0](aListePaysBL.getSelectedCellText('ColBons'),aListePaysBL.getSelectedCellText('ColCommandes'));
			window.close();
		}

  } catch (e) {
    recup_erreur(e);
  }
}


function pressOnTree(ev) {
  try {

    if (ev.keyCode==13) {
	    ouvrirPays();
    }

  } catch (e) {
    recup_erreur(e);
  }
}


function init_tree() {
  try {

    aListePaysBL.setParam("Affaire_Id", ParamValeur("Affaire_Id"));
		aListePaysBL.setParam("Commande_Id", ParamValeur("Commande_Id"));
		aListePaysBL.setParam("Mode_Facturation", ParamValeur("Mode_Facturation"));
		aListePaysBL.initTree();

  } catch (e) {
    recup_erreur(e);
  }
}
