/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");


var gEtablissementDefaut;
var gDepotDefautRC;
var gSiteWeb;



function init() {
  try {

		gEtablissementDefaut = getProfil().getEtabId();

		var qDepotDefaut = new QueryHttp("Facturation/Commun/getDepotDefautEts.tmpl");
		qDepotDefaut.setParam("Etablissement_Id", gEtablissementDefaut);
		var result = qDepotDefaut.execute();
		gDepotDefautRC = result.responseXML.documentElement.getAttribute('Depot_RC');

		gSiteWeb = getConfig().isECommerce();

		document.getElementById('deck').selectedIndex = 0;
  	omr_init();

	} catch (e) {
    recup_erreur(e);
  }
}


function retourMenuRetours() {
	try {

		document.getElementById('omr-pdfRetour').setAttribute("src", "");
		document.getElementById("omr-deckMenuRetours").selectedIndex = 0;
		document.getElementById('bMenuRetours').collapsed = true;

	} catch (e) {
    recup_erreur(e);
  }
}


function retourMenuPrincipal() {
	try {

		window.location = "chrome://opensi/content/facturation/user/menu_principal.xul";

	} catch (e) {
    recup_erreur(e);
  }
}
